<?php
// Check sales orders and salesorder line on updated data
// and add proper data for processing
// calculate order and orderline totals
?>

<?php

// function get actual system values from system table
	require('system_values.html5');

// calculate orderline value
	require('func_calc_orderline_value.php');
	
// determine orderline price
	require('func_plu_price.php');
	
// function crate alias for records
	require('create_alias.php');
	
// function update stock planning
	require('stock_planning.php');
?>

<?php
function calculateOrder($db, $org_code, $pid, $price_date_code){
// $pid should be set in base source

// check orderlines on consistence 
	$orderline_record = array();
	$order_record = array();
	$orderline_plu = array();

//	$price_date_code = $this->replaceInsertTags('{{const::price_date_code}}');

// get order record
	$sw_order = '';
	$order_value = 0;
	$set_price = 0;
	$v_klant_id = '';
	$price_date = '';
	$credit_sign = 1;

	$stmt_order = $db->prepare('SELECT * FROM ctlg_bestelorders WHERE id = ? AND org_code = ? AND
					status <= ? AND status_del != ? FOR UPDATE');
	$stmt_order->bindValue(1, $pid);
	$stmt_order->bindValue(2, $org_code);
	$stmt_order->bindValue(3, '2');
	$stmt_order->bindValue(4, '1');	
	$stmt_order->execute();
	$order_record = $stmt_order->fetch();
	while (is_array($order_record)){
		$order_value = 0;
		$sw_del_order = '' ;

// change ordertyp in case of credit order
//		if($order_record['credit_order'] == 'C'){
//			$order_record['ordertype'] = 'RT';
//		}
		if ($order_record['ordertype'] == 'RT'){
			$order_record['credit_order'] = 'C';
		}
				
// check ordernummer was given
		if ($order_record['ordernummer'] == ''){
			$order_record['ordernummer'] = get_system_nmbr('sales_order', $db, $org_code);
		}
		if ($order_record['pid'] != $v_klant_id){
			$client_record = getClientData($db, $org_code, $order_record['klantnummer']);
			if($order_record['lever_tijdstip'] == ''){
				$order_record['lever_tijdstip'] = $client_record['time_slot'];
			}
			$v_klant_id = $order_record['pid'];
		}
		
// select orderline records
		$stmt_line = $db->prepare('SELECT * FROM ctlg_bestelregels WHERE org_code = ? AND
						pid = ? AND status_del != ?	FOR UPDATE');
		$stmt_line->bindValue(1, $org_code);
		$stmt_line->bindValue(2, $pid);
		$stmt_line->bindValue(3, '1');
		$stmt_line->execute();
		$orderline_record = $stmt_line->fetch();
		while (is_array($orderline_record)){
			$price_set = 0;
// read products record
			if ($orderline_record['status'] <= '2'){
				$stmt_plu = $db->prepare('SELECT * FROM ctlg_producten WHERE id = ?');
				$stmt_plu->bindValue(1, $orderline_record['plu_id']);
				$stmt_plu->execute();
				$plu_record = $stmt_plu->fetch();
				if (floatval($plu_record['bestel_faktor']) == 0){
					$plu_record['bestel_faktor'] = 1;	
				}
// update orderline record quantities depending on units and quantities
				if (floatval($orderline_record['quantity2']) == 0){
					$orderline_record['quantity2'] = 1;
				}
				if (floatval($orderline_record['bestel_faktor']) == 0){
					$orderline_record['bestel_faktor'] = $plu_record['bestel_faktor'];
				}

// Ordertype of orderline should be same as order record
				$orderline_record['ordertype'] = $order_record['ordertype'];

// and calculate base quantity
				$credit_sign = 1;
				if($order_record['credit_order'] == 'C'){
					$credit_sign = -1;
				}

				$orderline_record['hoeveelheid'] = floatval($orderline_record['aantal_bestel_eh']) *
							floatval($orderline_record['quantity2']) * floatval($orderline_record['bestel_faktor']) *
							$credit_sign;

// determine price refence date
				$orderline_record['lever_datum'] = $order_record['lever_datum'];
				$orderline_record['delivery_time'] = strtotime('1970-01-01 '. substr($order_record['lever_tijdstip'],0,5));
				$price_date = intval($order_record['besteldatum']);
				if($price_date_code == 'D'){
					$price_date = intval($order_record['lever_datum']);
				}
					
				if ($orderline_record['ordertype'] == 'OF' || $orderline_record['ordertype'] == 'OK'){		// direct invoicing
					if (floatval($orderline_record['eenheidsprijs']) == 0 ){
// get price details gross, discounts, net

						$price_det = pluClientPrice($db, $org_code, $orderline_record['plu_id'], $orderline_record['klant_id'], 
									floatval($orderline_record['hoeveelheid']), $price_date, 0);
										
						$orderline_record['eenheidsprijs'] = $price_det['gross'];
						$orderline_record['price_net'] = $price_det['net'];
						$orderline_record['discount_perc'] = $price_det['disc_perc'];
						$orderline_record['discount_amnt'] = $price_det['disc_amnt'];
						$orderline_record['prijs_per'] = $price_det['price_per'];
					}
				}else{
					$orderline_record['lever_datum'] = $order_record['lever_datum'];
					$price_det = pluClientPrice($db, $org_code, $orderline_record['plu_id'], $orderline_record['klant_id'], 
									floatval($orderline_record['hoeveelheid']), $price_date, floatval($orderline_record['price_update']));
															
					$orderline_record['eenheidsprijs'] = $price_det['gross'];
					$orderline_record['price_net'] = $price_det['net'];
					$orderline_record['discount_perc'] = $price_det['disc_perc'];
					$orderline_record['discount_amnt'] = $price_det['disc_amnt'];
					$orderline_record['prijs_per'] = $price_det['price_per'];
				}

			
// check on set products
				$price_set = getSetPrice($db, $org_code, $orderline_record['plu_id'], $orderline_record['id'],
							floatval($orderline_record['hoeveelheid']), intval($orderline_record['lever_datum']), $orderline_record['klant_id']);
				$orderline_record['price_set'] = round($price_set, 2);
// calculate orderline total price
				$line_values = calcOrderlineValue2(floatval($orderline_record['eenheidsprijs']), floatval($orderline_record['prijsfaktor']),
						floatval($orderline_record['prijs_per']), $orderline_record['price_type'], floatval($orderline_record['price_addition']),
						floatval($orderline_record['hoeveelheid']), floatval($orderline_record['discount_perc']), floatval($orderline_record['discount_amnt']));
				
				$line_value = $line_values['total_value'];
				$orderline_record['prijs_total'] = round($line_value,2);
				$orderline_record['price_unit_new'] = round($line_values['unit_price'],2);

				if (strlen($orderline_record['bestel_eenh']) == 0){
					$orderline_record['bestel_eenh'] = $plu_record['bestel_eenh'];			
				}
				$orderline_record['eenheid'] = $plu_record['eenheid'];
				$orderline_record['ordernummer'] = $order_record['ordernummer'];
				$orderline_record['ref_internal'] = $order_record['ref_internal'];
				$orderline_record['prijsfaktor'] = $plu_record['prijsfaktor'];
				$orderline_record['prijs_per'] = $plu_record['prijs_per'];
				$orderline_record['prijs_eenheid'] = $plu_record['prijs_eenheid'];
				$orderline_record['status'] = '2';
				
// write orderline log-record
				if ($orderline_record['reset'] == '1'){
					$orderline_record['count_update'] = intval($orderline_record['count_update']) + 1;
					createOrderLog($db, $org_code, $orderline_record);
				}	
				$orderline_record['reset'] = '';

// Update planning data
				$quantity_planned = floatval($orderline_record['hoeveelheid']) - floatval($orderline_record['quantity_planned']);
				updProdSalesPlan($db, $org_code, $orderline_record['plu_id'], $quantity_planned, intval($order_record['lever_datum']));
				$orderline_record['quantity_planned'] = $orderline_record['hoeveelheid'];
	
				$where_array = array();
				$where_array['id'] = $orderline_record['id'];
				$db->update('ctlg_bestelregels', $orderline_record, $where_array);
			}

// sum ordervalue
			$order_value = $order_value + floatval($orderline_record['prijs_total']);
			
// check on direct production
			checkProdOrder1($db, $org_code, $plu_record['product_db_id'], $orderline_record['id'], floatval($orderline_record['hoeveelheid']),
				intval($order_record['lever_datum']), $order_record['lever_tijdstip'], $order_record['ordernummer'], $order_record['pid'],
				$order_record['user'], $order_record['ref_internal'], $orderline_record['lot_code_extern']);
// next orderline record
			$orderline_record = $stmt_line->fetch();					
		}
	
// Update order record
		$where_array = array();
		$where_array['id'] = $pid;

		$update_array = array();
		$update_array['ordernummer'] = $order_record['ordernummer'];
		$update_array['lever_tijdstip'] = $order_record['lever_tijdstip'];
		$update_array['order_value'] = round($order_value,2);
		$update_array['ordertype'] = $order_record['ordertype'];
		$update_array['credit_order'] = $order_record['credit_order'];
		$update_array['status_upd'] = '';		
		$update_array['status'] = '1';	
		$db->update('ctlg_bestelorders', $update_array, $where_array);

// next order record
		$order_record = $stmt_order->fetch();	
	}
}

// creare orderline log/history record
	function createOrderLog($db, $org_code, $data){
		
		$record = array();
			
		$record['alias'] = createAlias(15);
		$record['org_code'] = $data['org_code'];
		$record['pid'] = $data['id'];
		$record['ordernummer'] = $data['ordernummer'];
		$record['plu_id'] = $data['plu_id'];
		$record['hoeveelheid'] = $data['hoeveelheid'];
		$record['aantal_bestel_eh'] = $data['aantal_bestel_eh'];				
		$record['lot_code_extern'] = $data['lot_code_extern'];
		$record['tekst'] = $data['tekst'];
		$record['price_type'] = $data['price_type'];
		$record['price_addition'] = $data['price_addition'];
		$record['eenheidsprijs'] = $data['eenheidsprijs'];
		$record['price_update'] = $data['price_update'];
		$record['bestel_faktor'] = $data['bestel_faktor'];	
		$record['bestel_eenh'] = $data['bestel_eenh'];
		$record['price_unit_new'] = $data['price_unit_new'];
		$record['eenheid'] = $data['eenheid'];
		$record['prijs_per'] = $data['prijs_per'];
		$record['prijsfaktor'] = $data['prijsfaktor'];
		$record['price_net'] = $data['price_net'];
		$record['discount_perc'] = $data['discount_perc'];
		$record['discount_amnt'] = $data['discount_amnt'];
		$record['prijs_eenheid'] = $data['prijs_eenheid'];
		$record['prijs_total'] = $data['prijs_total'];
		$record['lever_datum'] = $data['lever_datum'];
		$record['delivery_time'] = $data['delivery_time'];
		$record['ref_internal'] = $data['ref_internal'];
		$record['user_name'] = $data['user_name'];	
		$record['last_timestamp'] = $data['last_timestamp'];
		
		$db->insert('ctlg_bestelregels_log', $record);
		
		return;
	}
?>

<?php
// chekc for set records and update and/or create
	function  getSetPrice($db, $org_code, $plu_id, $orderline_id, $quantity, $date_delivery, $client_id){
		$setprice = 0;
		$quantity_set = 0;
		
		$stmt = $db->prepare('SELECT * FROM ctlg_product_sets WHERE pid = ?');
		$stmt->bindValue(1, $plu_id);
		$stmt->execute();
		$record = $stmt->fetch();
		if(!is_array($record)){
			return 0;
		}
// check for orderline check record, create if none
		$stmt = $db->prepare('SELECT * FROM ctlg_orderline_set WHERE pid = ? FOR UPDATE');
		$stmt->bindValue(1, $orderline_id);
		$stmt->execute();
		$set_record = $stmt->fetch();
		if(!is_array($set_record)){
// create orderline_set records
			$setprice = createOrderlineSet($db, $org_code, $plu_id, $orderline_id, $quantity, $date_delivery, $client_id);
			return $setprice;
		}
		while (is_array($set_record)){
// update orderline set data
			$quantity_set = ceil($quantity / floatval($set_record['devider']) * floatval($set_record['multiplier']));
// set_qauantity per set_per: price = quanity/set_per*set_quantity*unit_price
			$setprice = $setprice + $quantity_set * floatval($set_record['price_unit']) / floatval($set_record['price_per']);
// update set_rccord at change
			if (intval($set_record['date_delivery']) != $date_delivery || floatval($set_record['quantity']) != $quantity_set){
				$set_record['date_delivery'] = $date_delivery;
				$set_record['quantity'] = $quantity_set;

				$where_array = array();
				$where_array['id'] = $set_record['id'];
				$db->update('ctlg_orderline_set', $set_record, $where_array);			
			}

			$set_record = $stmt->fetch();			
		}
		return $setprice;
	}

// create orderline set
	function createOrderlineSet($db, $org_code, $plu_id, $orderline_id, $quantity, $date_delivery, $client_id){
		$setprice = 0;
		$set_record = array();
		
		$stmt = $db->prepare('SELECT * FROM ctlg_product_sets WHERE pid = ?');
		$stmt->bindValue(1, $plu_id);
		$stmt->execute();
		$record = $stmt->fetch();
		while(is_array($record)){
			$prod_db_record = getProdDbData1($db, $org_code, $record['product_db_id']);
			if (is_array($prod_db_record)){
				$set_record['deposit_code'] = $prod_db_record['deposit_code'];
			}else{
				$set_record['deposit_code'] = '';
			}
// check price per not zero
			if(floatval($record['price_per']) == 0){
				$record['price_per'] = 1;
			}
			if(intval($record['price_unit']) == 0){
				$record['price_unit'] = 1;
			}			
			$set_record['pid'] = $orderline_id;
			$set_record['org_code'] = $org_code;
			$set_record['alias'] = createAlias(15);
			$set_record['transaction_code'] = 'V1';
			$set_record['product_db_id'] = $record['product_db_id'];
			$set_record['multiplier'] = $record['multiplier'];
			$set_record['devider'] = $record['devider'];
			$set_record['price_unit'] = $record['price_unit'];
			$set_record['price_per'] = $record['price_per'];
			$set_record['unit'] = $record['unit'];
			$set_record['vat_code'] = $record['vat_code'];
			$set_record['date_delivery'] = $date_delivery;
			$set_record['client_id'] = $client_id;
			$set_record['quantity'] = ceil($quantity / floatval($record['devider']) * floatval($record['multiplier']));
// create orderline set record
			$db->insert('ctlg_orderline_set', $set_record);

			$setprice = $setprice + round(floatval($set_record['quantity']) * floatval($set_record['price_unit']) /
						floatval($set_record['price_per']), 2);
// get next set record			
			$record = $stmt->fetch();			
		}
		return $setprice;
}

// get Product_databse data
	function getProdDbData1($db, $org_code, $id){
		$stmt = $db->prepare('SELECT * FROM ctlg_product_database WHERE id = ? AND org_code = ?');
		$stmt->bindValue(1, $id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;
	}

// get client data
	function getClientData($db, $org_code, $id){
		$stmt = $db->prepare('SELECT * FROM ctlg_klanten WHERE id = ? AND org_code = ?');
		$stmt->bindValue(1, $id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;		
	}
	
// check production order creation for orderline
	function checkProdOrder1($db, $org_code, $id, $orderline_id, $quantity, $date_prod, $prod_time,
			$order_nmbr, $client_id, $user_name, $ref_internal, $lot_code_extern){
// get product database data
		$prod_db_record = getProdDbData1($db, $org_code, $id);
		if(is_array($prod_db_record) && intval($prod_db_record['make_product_id']) > 0){
// create production order			
			createProdOrder1($db, $org_code, $prod_db_record['make_product_id'],
				$date_prod, $prod_time, $quantity, $orderline_id, $order_nmbr, $user_name,
				$client_id, $ref_internal, $lot_code_extern);
		}
	}
	
// create/update production order record
	function createProdOrder1($db, $org_code, $product_db_id, $date_prod, $time_slot, $quantity,
		$order_line_id, $order_nmbr, $user_name, $client_id, $ref_internal, $lot_code_extern){

		$prod_record = array();
		$prod_order_id = 0;
		$sw_upd = '';

// get make_product
		$stmt = $db->prepare('SELECT * FROM ctlg_maak_producten WHERE id = ? AND org_code = ?');
		$stmt->bindValue(1, $product_db_id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		if(is_array($record)){
// calculate quantity of production order
			$quantity = $quantity / (100-floatval($record['waste_perc'])) * 100;
			$quantity = floatval($record['batch_hvh']) + 
					max(0, ceil($quantity - floatval($record['batch_hvh'])) /
						floatval($record['batch_stap']) * floatval($record['batch_stap']));

// check production order already exists
			$prod_record = getProdOrder1($db, $org_code, $order_line_id);
			if(!is_array($prod_record)){
				$prod_record = array();
				$prod_record['alias'] = createAlias(15);
				$prod_record['org_code'] = $org_code;
				$prod_record['status_order'] = '1';
				$prod_record['order_line_id'] = $order_line_id;
				$prod_record['time_slot'] = $time_slot;
				$sw_upd = 'A';
			}else{
				$sw_upd = 'U';
			}
// create production order
			$prod_record['last_timestamp'] = strtotime('today CET');
			$prod_record['maak_product_id'] = $record['id'];
			$prod_record['prod_date'] = $date_prod;
			$prod_record['date_start'] = $date_prod;
			$prod_record['omschrijving'] = $record['recept_naam'];
			$prod_record['opmerking'] = '';
			$prod_record['hoeveelheid'] = $quantity;
			$prod_record['lot_code'] = $lot_code_extern;
			if (floatval($record['make_factor']) == 0){
				$record['make_factor'] = 1;
			}
			$prod_record['prod_bins'] = ceil($quantity * floatval($record['make_factor']) / 45 * (100 + floatval($record['waste_perc']))/100 );
			$prod_record['quantity_planned'] = $quantity;
			$prod_record['eenheid'] = $record['eenheid'];
			$prod_record['prod_order'] = 'VO-'. $order_nmbr;
			$prod_record['transaction_code'] = 'P1';
			$prod_record['sign_multiplier'] = 1;
			$prod_record['user'] = $user_name;
			$prod_record['type_bom'] = 	$record['type_bom'];
			$prod_record['date_indicator'] = 'F';			// finish date
			$prod_record['location'] = $record['location'];
			$prod_record['lead_days'] = $record['lead_days'];
			$prod_record['lead_time'] = $record['lead_time'];
			$prod_record['order_nmbr'] = $order_nmbr;
			$prod_record['client_id'] = $client_id;
			$prod_record['ready_ind'] = $record['ready_ind'];
			$prod_record['ref_internal'] = $ref_internal;
			$prod_record['sort'] = '5';
			if($sw_upd == 'A'){
				$db->insert('ctlg_prod_opdracht', $prod_record);
				$prod_order_id = $db->lastInsertId();
			}else{
				$where_array = array();
				$where_array['id'] = $prod_record['id'];
				$db->update('ctlg_prod_opdracht', $prod_record, $where_array);
				$prod_order_id = $prod_record['id'];
			}

		}		
		return $prod_order_id;										
	}

// get/check production order data
	function getProdOrder1($db, $org_code, $order_line_id){
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE order_line_id = ? AND org_code = ?');
		$stmt->bindValue(1, $order_line_id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();		
		
		return $record;
	}
	
	
?>
