<?php
// get next system number
if (!function_exists('get_system_nmbr')){
	function get_system_nmbr($system, $db, $org_code){	
			$stmt_systeem = $db->prepare('SELECT * FROM ctlg_system_values WHERE systeem_code = ? AND org_code = ? FOR UPDATE');
			$stmt_systeem->bindValue(1, $system);
			$stmt_systeem->bindValue(2, $org_code);
			$stmt_systeem->execute();
			$systeem_record = $stmt_systeem->fetch();
			if (!is_array($systeem_record)){
				$number = intval(date('y'). '0001');
				createSystemNmbr($system, $db, $org_code, $number);
			}else{
				$number = intval($systeem_record['last_number'] + 1);
				$update_array = array();
				$update_array['last_number'] = $number;
				$update_array['last_timestamp'] = strtotime(date('d-m-Y'));
				$where_array = array();
				$where_array['id'] = $systeem_record['id'];
				$db->update('ctlg_system_values', $update_array, $where_array);					
			}
			return $number;
	}
}
// create system record
if (!function_exists('createSystemNmbr')){
	function createSystemNmbr($system, $db, $org_code, $number){
		$systeem_record['last_number'] = $number;
		$systeem_record['systeem_code'] = $system;
		$systeem_record['org_code'] = $org_code;
		$systeem_record['last_timestamp'] = strtotime(date('d-m-Y'));
		$systeem_record['alias'] = $system. '_'. $systeem_record['last_number']. $systeem_record['last_timestamp'];						
// insert system record
		$db->insert('ctlg_system_values', $systeem_record);
		$number = intval($systeem_record['last_number']);
		return $number;
	}
}

// get last system number
if (!function_exists('getLastSystemNmbr')){
	function getLastSystemNmbr($system, $db, $org_code){
		$stmt_systeem = $db->prepare('SELECT * FROM ctlg_system_values WHERE systeem_code = ? AND org_code = ? FOR UPDATE');
		$stmt_systeem->bindValue(1, $system);
		$stmt_systeem->bindValue(2, $org_code);
		$stmt_systeem->execute();
		$systeem_record = $stmt_systeem->fetch();
		if (!is_array($systeem_record)){
			return 0;
		}else{
			return $number = intval($systeem_record['last_number']);
		}
	}
}
// update system number
if (!function_exists('updateLastSystemNmbr')){
	function updateLastSystemNmbr($system, $db, $org_code, $number){
		$stmt_systeem = $db->prepare('SELECT * FROM ctlg_system_values WHERE systeem_code = ? AND org_code = ? FOR UPDATE');
		$stmt_systeem->bindValue(1, $system);
		$stmt_systeem->bindValue(2, $org_code);
		$stmt_systeem->execute();
		$systeem_record = $stmt_systeem->fetch();
		if (!is_array($systeem_record)){
			createSystemNmbr($system, $db, $org_code, $number);
		}else{
			$update_array = array();
			$update_array['last_number'] = $number;
			$update_array['last_timestamp'] = strtotime(date('d-m-Y'));
			$where_array = array();
			$where_array['id'] = $systeem_record['id'];
			$db->update('ctlg_system_values', $update_array, $where_array);
		}
	}
}
?>