<?php
class PDF1 extends TCPDF{
// page and line counters	
	public static	$pdf_lines_counter = 99;
	public static	$pdf_lines_max	= 55;
	public static	$pdf_page_number = 0;
	public static 	$pdf_first_line = 4;
	public static 	$pdf_line_distance = 4;
	public static 	$pdf_char_multiply = 1.4;
	
// header image
	public static	$pdf_report_image = '';
	public static	$pdf_report_image_R = '';
	public static	$pdf_report_title = '';
	public static	$pdf_report_date = '';
	public static	$pdf_report_subject = '';
	
// init header and columns
	public static	$pdf_head_name = array();		// header field name values
	public static	$pdf_head_pos = array(array());	// header field posX, posT, length, print_pos

	public static	$pdf_col_name = array();	// column name, posX,Length, print_pos
	public static	$pdf_col_head_start_Y = 24;
	public static	$pdf_col_head_end_Y = 28;

// Dimensions
	public static 	$doc_font = 'times';
	public static 	$doc_detail_size = 9;
	public static 	$doc_header_size = 14;
	public static 	$unit = 'mm';
	public static 	$page_format = 'C9';
	public static 	$margin_left = '1';
	public static 	$margin_right = '1';
	public static 	$margin_top = '1';
	public static 	$margin_header = '1';
	public static 	$margin_footer = '1';
	public static 	$margin_pagebreak = '1';

//----------------------------------------------------------------------------------------	
// Delivery listing
//----------------------------------------------------------------------------------------
// PDF document defaults
	function Get_pdf_defaults(){
		$pdf_defaults = array(
				'report_title' => 'Report Title',
				'report_auteur' => 'system',
				'report_subject' => '',
				'report_date' => '',
				'keywords' => 'report keywords',
				'page_orientation' => 'P',
				'total_width' => '190',
				'margin_left' => '5',
				'margin_right' => '5',
				'margin_top' => '30',
				'margin_header' => '5',
				'margin_bottom' => '5',
				'font' => 'times',
				'char_header' => '14',
				'char_detail' => '10');
		return $pdf_defaults;
	}

// Init pdf document
	function Init_pdf_doc($pdf_prop){

		if ($pdf_prop['page_orientation'] == 'L') {
			$pdf_prop['total_width'] = 285;
		}else{
			$pdf_prop['total_width'] = 190;
		}

// Alias total # pages
// 		AliasNbPages('{pages}');

// set document information
		$this->SetCreator(PDF_CREATOR);
		$this->SetAuthor($pdf_prop['report_auteur']);
		$this->SetTitle($pdf_prop['report_title']);
		$this->SetSubject($pdf_prop['report_subject']);
		$this->SetKeywords($pdf_prop['keywords']);

// default header/footer
		$this->SetPrintHeader(true);
		$this->SetPrintFooter(true);
		$this->SetHeaderMargin($pdf_prop['margin_header']);
		$this->SetFooterMargin($pdf_prop['margin_footer']);

// set default monospaced font
		$this->SetDefaultMonospacedFont($pdf_prop['font']);
// 		$this->SetCellHeightRatio(0.8);
// set margins
		$this->SetMargins($pdf_prop['margin_left'], $pdf_prop['margin_top'], $pdf_prop['margin_right']);
// set auto page breaks
		$this->SetAutoPageBreak(TRUE, $pdf_prop['margin_bottom']);
// set image scale factor
// 		$this->SetImageScale(PDF_IMAGE_SCALE_RATIO);
	}
	
// Set document properties
	function Set_pdf_properties($font, $headersize, $detailsize){
		$pdf_doc_font = $font;
		$pdf_doc_header_size = $headersize;
		$pdf_doc_detail_size = $detailsize;
	}

// Set header properties
//	function Set_header($title, $date, $image, $value, $posy, $posx, $len){
	function Set_header($title, $date, $image, $report_name, $pos){
		self::$pdf_report_title = $title;
		self::$pdf_report_image = $image;
		self::$pdf_report_date = $date;
		self::$pdf_head_pos = $pos;
		$this->Set_header_value($report_name);
	}
	function Set_header2($title, $date, $image, $image_R, $report_name, $pos){
		$this->Set_header($title, $date, $image, $report_name, $pos);
		self::$pdf_report_image_R = $image_R;
	}
	
// Set header values
	function Set_header_value($report_name){
		self::$pdf_head_name = $report_name;
	}
	
// Set column properties
//	function Set_columns($name, $pos, $len){
	function Set_columns($name){
		self::$pdf_col_name = $name;
//		self::$pdf_col_len = $len;
//		self::$pdf_col_pos = $pos;
	}
	function Set_columns2($name, $start_Y, $end_Y){
		$this->Set_columns($name);
		self::$pdf_col_head_start_Y = $start_Y;
		self::$pdf_col_head_end_Y = $end_Y;
		self::$pdf_first_line = ($end_Y / self::$pdf_line_distance) - 1;	// recalculate 1st detail line
	}
	
// Header definition
	function Header(){
		$this->SetFont(self::$doc_font, 'B', self::$doc_header_size);
		// report title
//		$this->Image($webroot. 'files/tao/pictures/catch-all/logo.png',6,3,30,14);
		$this->Image(self::$pdf_report_image,6,3,30,14);
		$this->Image(self::$pdf_report_image_R,150,3,30,14);
		$this->SetXY(85,1);
//		$this->Cell(18,18, self::$pdf_report_title,0,0,'');
		$this->Cell(strlen(self::$pdf_report_title)*1.5,self::$doc_header_size, self::$pdf_report_title,0,0,'');
		$this->SetFont(self::$doc_font, 'B', self::$doc_detail_size);
		$this->SetXY(144,13);
		$this->Cell(9,9, 'Datum:',0,0,'');
		$this->SetXY(155,13);
		$this->Cell(9,9, self::$pdf_report_date,0,0,'');
		$n1 = count(self::$pdf_head_name);
		for ($i=0; $i<$n1; $i++){
			$this->setXY(self::$pdf_head_pos[$i][0], self::$pdf_head_pos[$i][1]);
			$this->Cell(self::$pdf_head_pos[$i][2]*1.5, 9, self::$pdf_head_name[$i],0,0,self::$pdf_head_pos[$i][3]);
		}
//		$this->Ln(9);
		$this->SetY(self::$pdf_col_head_start_Y);
		
// PDF column header lines;
// Cell( $w, $h = 0, $txt = '', $border = 0, $ln = 0, $align = '', $fill = false, $link = '', $stretch = 0, $ignore_min_height = false, $calign = 'T', $valign = 'M' );
		$this->SetFont(self::$doc_font, 'B', self::$doc_detail_size);
		$this->SetFillColor(127);
		$n1 = count(self::$pdf_col_name);
		for ($i=0; $i<$n1; $i++){						// column name, posX and Length
			$this->setX(self::$pdf_col_name[$i][1]*self::$pdf_char_multiply);
			$this->Cell(self::$pdf_col_name[$i][2]*self::$pdf_char_multiply, 6, self::$pdf_col_name[$i][0],1,0,self::$pdf_col_name[$i][3],1);
//			$this->setX(self::$pdf_col_pos[$i]);
//			$this->Cell(self::$pdf_col_len[$i]*self::$pdf_char_multiply, 5, self::$pdf_col_name[$i],1,0,'',1);
		}
//		$this->Ln();
		$this->SetY(self::$pdf_col_head_end_Y);
	}

// Footer definition
	function Footer(){
		$this->SetFont(self::$doc_font, '', self::$doc_detail_size);
		$this->SetY(-15);
		$this->Cell(0,10, 'blad '.$this->getAliasNumPage(). '/ '. $this->getAliasNbPages() ,0,0, 'C');
	}

		
// Detail line definition		
	function Detail($col_value){

		$this->Check_page_skip(1);
		
		$this->SetFont(self::$doc_font, '', self::$doc_detail_size);
		$this->SetY(self::$pdf_lines_counter * self::$pdf_line_distance);
		$n1 = count($col_value);
		for ($i=0; $i<$n1; $i++){
			$this->setX(self::$pdf_col_name[$i][1]*self::$pdf_char_multiply);
			$this->Cell(self::$pdf_col_name[$i][2]*self::$pdf_char_multiply, 6, $col_value[$i],0,0,self::$pdf_col_name[$i][3],0);
		}
	}
// Detail line definition addtional information		
	function Detail2($col_value){

		$this->Check_page_skip(1);
		
		$this->SetFont(self::$doc_font, 'B', self::$doc_detail_size);
		$this->SetY(self::$pdf_lines_counter * self::$pdf_line_distance);
		$n1 = count($col_value);
		for ($i=0; $i<$n1; $i++){
			$this->setX(self::$pdf_col_name[$i][1]*self::$pdf_char_multiply);
			$this->Cell(self::$pdf_col_name[$i][2]*self::$pdf_char_multiply, 6, $col_value[$i],0,0,self::$pdf_col_name[$i][3],0);
		}
	}


// check page skip
	function Check_page_skip($lines){
		if (self::$pdf_lines_counter >= self::$pdf_lines_max){
			self::$pdf_page_number++;
			$this->AddPage();
			self::$pdf_lines_counter = self::$pdf_first_line;
		}
		self::$pdf_lines_counter = self::$pdf_lines_counter + $lines;
	}

// Footer_line printing
	function Footer_line(){
		$this->Check_page_skip(99);
	}
	
// Close pdf file
	function Close_pdf($pdf_file, $type){
		ob_end_clean();
		$this->close();
		$this->Output($pdf_file, $type);
	}

// Detail line definition		
	function Debugline($value){
		$this->Check_page_skip(1);
		
		$this->SetFont(self::$doc_font, '', self::$doc_detail_size);
		$this->SetY(self::$pdf_lines_counter * self::$pdf_line_distance);
		$this->setX(2);
		$this->Cell(120, 5, $value,0,0,'',0);
	}
// -------------- end of class --------------------
}
?>

<?php
// ---------- get standard client dependent data -------
	$webroot = $this->replaceInsertTags('{{const::webroot}}');
	$client_folder = $this->replaceInsertTags('{{const::client_folder}}');
	$logo = $this->replaceInsertTags('{{const::company_logo}}');
	$logo2 = $this->replaceInsertTags('{{const::company_logo2}}');

// ----------------------------------------------------
// -------------- end of initialize PDF print ---------
// ----------------------------------------------------
?>


