<?php
// get productprice, no client, no scale
if(!function_exists("plu_prijs")) {
	function plu_prijs($plu_id, $org_code, $date_in, $db){
		$price_det = array();
		
		$client_id = '';
		$scale = 0;
		$price_det = pluClientPrice($db, $org_code, $plu_id, $client_id, $scale, $date_in, 0);
		return $price_det['net'];
	}
}
// get productprice, no client, no scale, return price details with discounts
if(!function_exists("plu_prijs_detail")) {
	function plu_prijs_detail($plu_id, $org_code, $date_in, $db){
		$price_det = array();
		
		$client_id = '';
		$scale = 0;
		$price_det = pluClientPrice($db, $org_code, $plu_id, $client_id, $scale, $date_in, 0);
		return $price_det;
	}
}

// get product scale price
if(!function_exists("getScalePrice")) {
	function getScalePrice($db, $org_code, $pid, $scale){
		
		$price_det = array();
		$price_det['net'] = 0;
		$price_det['disc_amnt'] = 0;
		$price_det['disc_perc'] = 0;
		$price_det['gross'] = 0;
		$price_det['price_per'] = 1;
		
		$stmt_table = $db->prepare('SELECT * FROM ctlg_price_scales WHERE pid = ? AND
					org_code = ? ORDER BY scale');
		$stmt_table->bindValue(1, $id);
		$stmt_table->bindValue(2, $org_code);
		$stmt_table->execute();
		$record = $stmt_table->fetch();
// get scale price, scale is between to row scales
		while (is_array($record)){
			if (floatval($record['scale']) <= $scale){
				$price_det['net'] = (floatval($record['price']) - floatval($record['discount_amnt'])) *
					(100% - floatval($record['discount_perc']));
				$price_det['gross'] = floatval($record['price']);
				$price_det['disc_amnt'] = floatval($record['discount_amnt']);
				$price_det['disc_perc'] = floatval($record['discount_perc']);
				$price_det['price_per'] = floatval($record['price_per']);
			}else{
				break;
			}
			$record = $stmt_table->fetch();
		}
		
		return $price_det;	
	}
}
// get product price, per client with scale
if(!function_exists("pluClientPrice")) {
	function pluClientPrice($db, $org_code, $plu_id, $client_id, $scale, $date_in, $price_new){

		$price_det = array();
		$price_det['net'] = 0;
		$price_det['disc_amnt'] = 0;
		$price_det['disc_perc'] = 0;
		$price_det['gross'] = 0;		
		$price_det['price_per'] = 1;

// special price entered	
		if (floatval($price_new) != 0){
			$price_det['net'] = $price_new;
			$price_det['gross'] = $price_new;
		}else{
// get client price
			if (intval($client_id) > 0){
				$price_det = pluPrice($db, $org_code, $plu_id, $client_id, $scale, $date_in);
			}
// no plu_price or no client
			if (floatval($price_det['gross']) == 0){
				$price_det = pluPrice($db, $org_code, $plu_id, '', $scale, $date_in);
			}
		}
		return $price_det;
	}
}

if(!function_exists("pluPrice")) {
	function pluPrice($db, $org_code, $plu_id, $client_id, $scale, $date_in){

			$price_det = array();
			$price_det['net'] = 0;
			$price_det['disc_amnt'] = 0;
			$price_det['disc_perc'] = 0;
			$price_det['gross'] = 0;
			$price_det['price_per'] = 1;
			
			$standard_det = $price_det;
			$campagne_det = $price_det;
			$client_det = $price_det;
		
			$date_ymd = date('Ymd', $date_in);

			$aanbieding_record = array();
		
			$stmt_aanbieding = $db->prepare('SELECT * FROM ctlg_aanbiedingen WHERE pid = ? AND org_code = ? AND client_id = ?');
			$stmt_aanbieding->bindValue(1, $plu_id);
			$stmt_aanbieding->bindValue(2, $org_code);
			$stmt_aanbieding->bindValue(3, $client_id);
			$stmt_aanbieding->execute();
			$aanbieding_record = $stmt_aanbieding->fetch();

			while (is_array( $aanbieding_record)){
// Standard prices
				if (substr($aanbieding_record['prijstype'],0,1) == 'S'){
					$standard_det['net'] = (floatval($aanbieding_record['eenheidsprijs']) - floatval($aanbieding_record['discount_amnt'])) *
						(1 - floatval($aanbieding_record['discount_perc'])/100);
					$standard_det['disc_amnt'] = floatval($aanbieding_record['discount_amnt']);
					$standard_det['disc_perc'] = floatval($aanbieding_record['discount_perc']);
					$standard_det['gross'] = floatval($aanbieding_record['eenheidsprijs']);
					$standard_det['price_per'] = floatval($aanbieding_record['prijs_per']);
					if ($scale > 0){
						$price_det = getScalePrice($db, $org_code, $aanbieding_record['id'], $scale);
						if($price_det['net'] != 0){
							$standard_det = $price_det;
						}
					}
				}else{
// Special offer prices
					if (substr($aanbieding_record['prijstype'],0,1) == 'A' && date('Ymd', intval($aanbieding_record['startdatum'])) <= $date_ymd &&
							date('Ymd', intval($aanbieding_record['einddatum'])) >= $date_ymd){	
						$campagne_det['net'] = (floatval($aanbieding_record['eenheidsprijs']) - floatval($aanbieding_record['discount_amnt'])) *
								(1 - floatval($aanbieding_record['discount_perc'])/100);
						$campagne_det['disc_amnt'] = floatval($aanbieding_record['discount_amnt']);
						$campagne_det['disc_perc'] = floatval($aanbieding_record['discount_perc']);
						$campagne_det['gross'] = floatval($aanbieding_record['eenheidsprijs']);
						$campagne_det['price_per'] = floatval($aanbieding_record['prijs_per']);						
						if ($scale > 0){
							$price_det = getScalePrice($db, $org_code, $aanbieding_record['id'], $scale);
							if($price_det['net'] != 0){
								$campagne_det = $price_det;
							}
						}
					}
// Client prices
					if (substr($aanbieding_record['prijstype'],0,1) == 'K' && date('Ymd', intval($aanbieding_record['startdatum'])) <= $date_ymd &&
							date('Ymd', intval($aanbieding_record['einddatum'])) >= $date_ymd){
						$client_det['net'] = (floatval($aanbieding_record['eenheidsprijs']) - floatval($aanbieding_record['discount_amnt'])) *
							(1 - floatval($aanbieding_record['discount_perc'])/100);
						$client_det['disc_amnt'] = floatval($aanbieding_record['discount_amnt']);
						$client_det['disc_perc'] = floatval($aanbieding_record['discount_perc']);
						$client_det['gross'] = floatval($aanbieding_record['eenheidsprijs']);
						$client_det['price_per'] = floatval($aanbieding_record['prijs_per']);
						if ($scale > 0){
							$price_det = getScalePrice($db, $org_code, $aanbieding_record['id'], $scale);
							if($price_det['net'] != 0){
								$client_det = $price_det;
							}
						}
					}
				}
				$aanbieding_record = $stmt_aanbieding->fetch();						
			}

// if no client or campaign price, then standar price from product data
			if ($client_det['gross'] != 0){
				return $client_det;
			}
			if ($campagne_det['gross'] != 0){
				return $campagne_det;
			}else{
				if ($standard_det['gross'] == 0){
					$stmt_plu = $db->prepare('SELECT * FROM ctlg_producten WHERE id = ?');
					$stmt_plu->bindValue(1, $plu_id);
					$stmt_plu->execute();
					$plu_record = $stmt_plu->fetch();
					if(is_array($plu_record)){
						$standard_det['net'] = floatval($plu_record['eenheidsprijs']);
						$standard_det['gross'] = floatval($plu_record['eenheidsprijs']);
						$standard_det['price_per'] = floatval($plu_record['prijs_per']);
					}
				}
				return $standard_det;
			}
	}
}
?>