<?php
// FUNCTION TO UPDATE OMZET RECORDS
// THIS UPDATES THE  CTLG_OMZET TABLE

if(!function_exists("Update_dmwy")) {
	function Update_dmwy($record){
		$record['jaar'] = date('Y', intval($record['datum']));
		$record['maand'] = date('m', intval($record['datum']));
		$record['week'] = date('W', intval($record['datum']));
		$record['dag'] = date('d', intval($record['datum']));
		return $record;
	}
}

// update omzet record with cash difference and kas_begin
if(!function_exists("UpdateOmzetRecord")) {
	function UpdateOmzetRecord($db, $omzet_record, $kas_begin){
		$kas_eind = 0;
// revenu on delayed Cash invoicing			
//		$omzet_record['omzet_kas_fakt'] = number_format(RevenueOnInvoice($db, $omzet_record['datum'], 'OK'),2, '.', '');
// revenu on invoicing				
//		$omzet_record['omzet_fakturen'] = number_format(RevenueOnInvoice($db, $omzet_record['datum'], 'OF'),2, '.', '');
// Cash register revenue
		if (floatval($omzet_record['kas_reset']) > 0){
			$omzet_record['kas_begin'] = $omzet_record['kas_reset'];  // begin kas aanpassing
		}else{
			$omzet_record['kas_begin'] = $kas_begin;	// equel end-cash previous salesday
		}
//		$kas_verschil = -1 *( $kas_begin + $omzet_record['kas_omzet'] - $omzet_record['kas_uitgaven'] - $omzet_record['pin_betaling'] - 	$omzet_record['omzet_oprekening'] - $omzet_record['kas_eind']);
		$kas_eind = floatval($omzet_record['kas_begin']) + floatval($omzet_record['kas_omzet']) - floatval($omzet_record['kas_uitgaven']) -
					floatval($omzet_record['pin_betaling']) - floatval($omzet_record['omzet_oprekening']) + floatval($omzet_record['omzet_kas_fakt']);

		$omzet_record['kas_verschil'] = number_format(floatval($omzet_record['kas_eind']) - $kas_eind,2, '.', ''); // calculated-cash money minus real-cash money
// set values to 2 decimals
		$omzet_record['kas_eind'] = number_format(floatval($omzet_record['kas_eind']),2, '.', '');
		$omzet_record['kas_uitgaven'] = number_format(floatval($omzet_record['kas_uitgaven']),2, '.', '');
		$omzet_record['kas_omzet'] = number_format(floatval($omzet_record['kas_omzet']),2, '.', '');
		$omzet_record['pin_betaling'] = number_format(floatval($omzet_record['pin_betaling']),2, '.', '');
		$omzet_record['omzet_oprekening'] = number_format(floatval($omzet_record['omzet_oprekening']),2, '.', '');
		$omzet_record['kas_afstort'] = number_format(floatval($omzet_record['kas_afstort']),2, '.', '');
		$omzet_record['omzet_kas_fakt'] = number_format(floatval($omzet_record['omzet_kas_fakt']),2, '.', '');
		$omzet_record['omzet_fakturen'] = number_format(floatval($omzet_record['omzet_fakturen']),2, '.', '');

		return $omzet_record;
	}
}


if(!function_exists("UpdateOmzet")) {
	function UpdateOmzet($db, $org_code, $date_from, $date_to){
			
		$omzet_record = array();
		$kas_begin = 0;
		
// select omzet records
		$stmt_omzet = $db->prepare('SELECT * FROM ctlg_omzet WHERE org_code = ? and datum >= ? and datum <= ? ORDER BY datum FOR UPDATE');
		$stmt_omzet->bindValue(1, $org_code);
		$stmt_omzet->bindValue(2, $date_from);
		$stmt_omzet->bindValue(3, $date_to);
		$stmt_omzet->execute();
		$omzet_record = $stmt_omzet->fetch();
		if (!is_array($omzet_record)){
			$eof = 1;
		}else{
			$kas_begin = floatval($omzet_record['kas_begin']);	
		}
// start updating record for report period		
		while ($eof == 0){
			$omzet_record = Update_dmwy($omzet_record);
			if (floatval($omzet_record['klanten']) != 0){	// Sunday
				$omzet_record = UpdateOmzetRecord($db, $omzet_record, $kas_begin);
			}
			$kas_begin = number_format(floatval($omzet_record['kas_eind']) - floatval($omzet_record['kas_afstort']),2, '.', '');
// update omzet record
			$where_array = array();
			$where_array['id'] = $omzet_record['id'];
			$db->update('ctlg_omzet', $omzet_record, $where_array);
// cash begin next day = cash_end current day

			$omzet_record = $stmt_omzet->fetch();
			if (!is_array($omzet_record )){
				$eof = 1;
			}
		}
	}
}

?>