<?php
// ####################
// function transitioning picklist records
// updating orderlineStatus
// Requires:  function "plu_prijs"
// ####################
	function update_picklist($db, $org_code, $picklist_record, $aantal_picked, $counter, $tstamp, $user_name, $verzenddatum){
		$orderline_record = array();
		$order_record = array();
		$plu_record = array();
		$client_record = array();
		$verzend_record = array();
		$total_delivered = 0;
		$total_picklist = 0;
		
// get orderline record
				$stmt_line = $db->prepare('SELECT * FROM ctlg_bestelregels WHERE id = ?');
				$stmt_line->bindValue(1, $picklist_record['order_rgl_id']);
//				$stmt_line->bindValue(1, $picklist_record['pid']);
				$stmt_line->execute();
				$orderline_record = $stmt_line->fetch();
				
// if nothing picked, no processing order and verzend records
				if ($aantal_picked > 0){
// get prijsfaktor from PLU record
					if (floatval($orderline_record['prijsfaktor']) == 0 || $orderline_record['prijs_eenheid'] == '' ||
							$orderline_record['prijs_per'] == ''){
						$stmt_plu = $db->prepare('SELECT * FROM ctlg_producten WHERE id = ?');
						$stmt_plu->bindValue(1, $picklist_record['plu_id']);
						$stmt_plu->execute();
						$plu_record = $stmt_plu->fetch();
						if (floatval($orderline_record['prijsfaktor']) == 0){
							$orderline_record['prijsfaktor'] = $plu_record['prijsfaktor'];						
						}
						if ($orderline_record['prijs_eenheid'] == '') {
							$orderline_record['prijs_eenheid'] = $plu_record['prijs_eenheid'];
						}
						if ($orderline_record['prijs_per'] == '') {
							$orderline_record['prijs_per'] = $plu_record['prijs_per'];
						}
					}
// get order record for orderdate				
					$stmt_order = $db->prepare('SELECT * FROM ctlg_bestelorders WHERE id =  ?');
					$stmt_order->bindValue(1, $orderline_record['pid']);
					$stmt_order->execute();
					$order_record = $stmt_order->fetch();
					$v_order_id = $order_record['id'];

					$verzend_record['referentie'] = $order_record['referentie'];
// get price on date of order
					if (floatval($orderline_record['eenheidsprijs']) == 0 ) {
						$verzend_record['eenheidsprijs'] = plu_prijs($picklist_record['plu_id'], $org_code, intval($order_record['besteldatum']), $db);
					}else{
						$verzend_record['eenheidsprijs'] = $orderline_record['eenheidsprijs'];
					}
					if (floatval($orderline_record['besteld_faktor']) == 0){
						$orderline_record['besteld_faktor'] = 1;
					}
// create order delivery record
					$aantal_bestel_eh = $aantal_picked / floatval($orderline_record['besteld_faktor']);
					$verzend_record['prijsfaktor'] = $orderline_record['prijsfaktor'];
					$verzend_record['prijs_eenheid'] = $orderline_record['prijs_eenheid'];
					$verzend_record['prijs_per'] = $orderline_record['prijs_per'];
					$verzend_record['bestel_eenh'] = $orderline_record['bestel_eenh'];
					$verzend_record['aantal_bestel_eh'] = number_format($aantal_bestel_eh, 0,".",".");
					$verzend_record['price_type'] = $orderline_record['price_type'];
					$verzend_record['price_addition'] = $orderline_record['price_addition'];
					$verzend_record['aantal_bestel_eh'] = number_format($aantal_bestel_eh, 0,".",".");
					$verzend_record['pid'] = $picklist_record['klant_id'];
					$verzend_record['alias'] = $picklist_record['alias']. '-'. $counter;
					$verzend_record['tstamp'] = $tstamp;
					$verzend_record['ordernummer'] = $picklist_record['ordernummer'];
					$verzend_record['bon_nummer'] = $picklist_record['bon_nummer'];
					$verzend_record['order_rgl_id'] = $picklist_record['order_rgl_id'];
					$verzend_record['klant_id'] = $picklist_record['klant_id'];
					$verzend_record['plu_id'] = $picklist_record['plu_id'];
					$verzend_record['aantal'] = $aantal_picked;
					$verzend_record['leverdatum'] = $verzenddatum;
					$verzend_record['transaction_code'] = 'V2';
					$verzend_record['sign_multiplier'] = 1;
					$verzend_record['eenheid'] = $picklist_record['eenheid'];
					$verzend_record['user_name'] = $user_name;
					$verzend_record['org_code'] = $org_code;
					$db->insert('ctlg_verzendingen', $verzend_record);
				}
				
// update orderline record
				$total_delivered = floatval($orderline_record['aantal_geleverd']) + $aantal_picked;
				$total_picklist =  floatval($orderline_record['hvh_picklist']) - floatval($picklist_record['aantal_picklist']);
// calulate accaptable quantity deviation for kg and gr
				if ($orderline_record['eenheid'] == 'kg' || $orderline_record['eenheid'] == 'gr') {
					if( $total_delivered / floatval($orderline_record['hoeveelheid']) > 0.50 ){
						$orderline_record['status'] = '3';
					}
				}else{
					if( $total_delivered - floatval($orderline_record['hoeveelheid']) >= 0 ){
						$orderline_record['status'] = '3';	
					}
				}
				$update_array = array();
				$update_array['hvh_picklist'] = $total_picklist;				
				if ($aantal_picked > 0){
					$update_array['eenheidsprijs'] = $verzend_record['eenheidsprijs'];
					$update_array['prijsfaktor'] = $verzend_record['prijsfaktor'];
					$update_array['prijs_eenheid'] = $verzend_record['prijs_eenheid'];
					$update_array['aantal_geleverd'] = $total_delivered;
					$update_array['status'] = $orderline_record['status'];
					$update_array['datum_geleverd'] = $tstamp;
				}
				$where_array = array();
				$where_array['id'] = $orderline_record['id'];
				$db->update('ctlg_bestelregels', $update_array, $where_array);

// delete picklist record
				$where_array = array();
				$where_array['id'] = $picklist_record['id'];
				$db->delete('ctlg_picklist', $where_array);
	}
?>