<?php
// Check production orders for readyness or completeness
// and add proper data for processing
?>

<?php
// function crate alias for records
	require('create_alias.php');

// function get actual system values from system table
	require('system_values.html5');
?>

<?php
// chekc Production order on completeness
function checkProdOrders($db, $org_code){
// $pid should be set in base source

// check orderlines on consistence 
	$record = array();

	$stmt_record = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE org_code = ? AND
				type_bom != ? AND status_order = ? FOR UPDATE');
	$stmt_record->bindValue(1, $org_code);
	$stmt_record->bindValue(2, 'RV');
	$stmt_record->bindValue(3, '');
	$stmt_record->execute();
	$record = $stmt_record->fetch();
	while (is_array($record)){
// get make record
		$make_record = getMakeData($db, $org_code, $record['maak_product_id']);
		if(is_array($make_record)){
// update production order
			$where_array = array();
			$where_array['id'] = $record['id'];
			$update_array = array();

// check on lot_code needed
			if ($record['lot_code'] == ''){
				$lot_code = createLotCode($db, $org_code, $make_record['lot_prefix']);
// create lot record
				$update_array['lot_code'] = $lot_code;
				addLotData($db, $org_code, $lot_code, $make_record['product_db_id'],
						$record['id'], $record['opmerking']);				
			}else{
// check on lot_code existance			
				$lot_record = checkLotCode($db, $org_code, $record['lot_code']);
				if (!is_array($lot_record)){
// create lot record
					addLotData($db, $org_code, $record['lot_code'], $make_record['product_db_id'],
						$record['id'], $record['opmerking']);
				}
			}

			$update_array['ready_ind'] = $make_record['ready_ind'];
			$update_array['type_bom'] = $make_record['type_bom'];
			$update_array['eenheid'] = $make_record['eenheid'];
			$update_array['omschrijving'] = $make_record['recept_naam'];
			if ($record['opmerking'] = ''){
				$update_array['opmerking'] = $make_record['tekst'];
			}
			$update_array['lead_time'] = $make_record['lead_time'];	
			$update_array['lead_days'] = $make_record['lead_days'];
			$update_array['location'] = $make_record['location'];			
			$update_array['status_order'] = '1';
			if($record['date_indicator'] == 'F'){
				$update_array['date_start'] = intval($record['prod_date']) + intval($make_record['lead_days'])
								+ intval($make_record['lead_time']);
			}else{
				$update_array['date_start'] = $record['prod_date'];
			}
			$db->update('ctlg_prod_opdracht', $update_array, $where_array);			
		}
// next production order record		
		$record = $stmt_record->fetch();					
	}
}

// chekc sub-order on completeness
function checkSubOrders($db, $org_code){
// $pid should be set in base source

// check orderlines on consistence 
	$record = array();

//	$price_date_code = $this->replaceInsertTags('{{const::price_date_code}}');
	$stmt_record = $db->prepare('SELECT * FROM ctlg_prod_opdracht_rgls WHERE org_code = ? AND
				sub_order_id > ? AND status_suborder = ? FOR UPDATE');
	$stmt_record->bindValue(1, $org_code);
	$stmt_record->bindValue(2, 0);
	$stmt_record->bindValue(3, '');
	$stmt_record->execute();
	$record = $stmt_record->fetch();
	while (is_array($record)){
		$status = '';
		$status = createProdOrder($db, $org_code, $record);
		
// update suborder orderline
		if($status == ''){
			$where_array = array();
			$where_array['id'] = $record['id'];

			$update_array = array();
			$update_array['status_suborder'] = '1';
			$db->update('ctlg_prod_opdracht_rgls', $update_array, $where_array);
		}
// next orderline record		
		$record = $stmt_record->fetch();					
	}
}
// check on readyness of production order
function checkOrderReady($db, $org_code){
// $pid should be set in base source

// check orderlines on consistence 
	$record = array();
	$trans_record = array();
				
	$stmt_record = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE org_code = ? AND
				type_bom != ? AND status < ? AND ready_ind = ? FOR UPDATE');
	$stmt_record->bindValue(1, $org_code);
	$stmt_record->bindValue(2, 'RV');
	$stmt_record->bindValue(3, '3');
	$stmt_record->bindValue(4, '2');
	$stmt_record->execute();
	$record = $stmt_record->fetch();
	while (is_array($record)){
// get production order lines for check
			$status = checkLinesReady($db, $org_code, $record['id']);
// update production order in case applicable lines are indicated ready
			if ($status == '3'){
				addTransProd($db, $org_code, $record, strtotime(date('Y-m-d')));
			}			
// next production order record		
		$record = $stmt_record->fetch();					
	}
}

// check on deleted orders from deleted walse-orderlines
	function checkDeleteOrders($db, $org_code, $client_id){
		
		$where_array = array();
		
		$stmt_record = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE org_code = ? AND
				type_bom != ? AND status < ? AND order_line_id > ? AND client_id = ? FOR UPDATE');
		$stmt_record->bindValue(1, $org_code);
		$stmt_record->bindValue(2, 'RV');
		$stmt_record->bindValue(3, '1');
		$stmt_record->bindValue(4, 0);
		$stmt_record->bindValue(5, $client_id);
		$stmt_record->execute();
		$record = $stmt_record->fetch();
		while (is_array($record)){
// chek on orderline record
			$stmt_orderline = $db->prepare('SELECT * FROM ctlg_bestelregels WHERE org_code = ? AND id = ? ');
			$stmt_orderline->bindValue(1, $org_code);
			$stmt_orderline->bindValue(2, $record['order_line_id']);
			$stmt_orderline->execute();
			$orderline_record = $stmt_orderline->fetch();
			if(!is_array($orderline_record)){
				delProdFromOrder($db, $org_code, $record['id']);
			}
// next production record
			$record = $stmt_record->fetch();
		}
		return;
	}

// delete prod_order from sales orderline
	function delProdFromOrder($db, $org_code, $order_line_id){
		$where_array = array();

		$stmt = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE org_code = ? AND order_line_id = ?');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $order_line_id);
		$stmt->execute();
		$record = $stmt->fetch();
		if(is_array($record)){
			$where_array['id'] = $record['id'];
			$db->delete('ctlg_prod_opdracht', $where_array);	// delete production order
		}
		return;
	}

// create lot code
	function createLotCode($db, $org_code, $lot_prefix){
// create lot code
		$system_lot = 'lot_number_'. $lot_prefix;
		$lot_nmbr = get_system_nmbr_2($system_lot, $db, $org_code, '2', '001');	

		return $lot_prefix. $lot_nmbr;
	}

// check lote code already available
	function checkLotCode($db, $org_code, $lot_code){
		$stmt = $db->prepare('SELECT * FROM ctlg_lot_registration WHERE org_code = ? AND lot_code = ?');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $lot_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;
	}

// add lot record to lot table
	function addLotData($db, $org_code, $lot_code, $product_db_id, $prod_order_id, $remark){
		$lot_record = array();

		$lot_record['org_code'] = $org_code;
		$lot_record['alias'] = createAlias(15);
		$lot_record['lot_code'] = $lot_code;
		$lot_record['product_db_id'] = $product_db_id;
		$lot_record['remark'] = $remark;
		$lot_record['prod_order_id'] = $prod_order_id;
		$lot_record['date'] = strtotime(date('Y-m-d'));
		$lot_record['last_timestamp'] = strtotime(date('Y-m-d'));
		$db->insert('ctlg_lot_registration', $lot_record);

		return;
	}

// Create transaction record
	function addTransProd($db, $org_code, $data, $date_ready){
		$trans_record = array();
		
		$trans_record['org_code'] = $data['org_code'];
		$trans_record['alias'] = createAlias(15);
		$trans_record['product_id'] = $data['id'];
		$trans_record['pid'] = $data['id'];
		$trans_record['datum_gereed'] = $date_ready;
		$trans_record['tijdstip'] = strtotime(date('H:m'));
		$trans_record['aantal'] = $data['hoeveelheid'];
		$trans_record['location'] = $data['location'];
		$trans_record['lot_code'] = $data['lot_code'];
		$trans_record['status'] = '9';
		$trans_record['transaction_code'] = 'P2';
		$trans_record['sign_multiplier'] = 1;
		$trans_record['user'] = $data['user'];
		$trans_record['last_timestamp'] = strtotime(date('Y-m-d'));
		$db->insert('ctlg_transacties_prod', $trans_record);

		return;
	}


function checkLinesReady($db, $org_code, $pid){
// orderlines with ready_in <> '' should be indicated as "ready" to complete prod_order

	$record = array();
	$status = '';
// get prod_order lines
	$stmt_record = $db->prepare('SELECT * FROM ctlg_prod_opdracht_rgls 
						WHERE org_code = ? AND pid = ? AND ready_ind >= ?');
	$stmt_record->bindValue(1, $org_code);
	$stmt_record->bindValue(2, $pid);
	$stmt_record->bindValue(3, '1');
	$stmt_record->execute();
	$record = $stmt_record->fetch();
	while (is_array($record)){
		$status = '3';
// check orderline for readyness/ delivered
		if($record['status'] < '3'){
			$status = '1';
			break;
		}
// next orderline record		
		$record = $stmt_record->fetch();					
	}
	return $status;
}


// create orderline set
	function createProdOrder($db, $org_code, $record){

		$make_record = getMakeData($db, $org_code, $record['sub_order_id']);

		if(is_array($make_record)){
// get location info
			$location_record = getLocationData($db, $org_code, $make_record['location']);
			if (!is_array($location_record) || intval($location_record['capacity_bin']) == 0){
				$location_record['capacity_bin'] = 1;
			}
// create prod_order record from sub-order
			$order_record = getProdOrder($db, $org_code, $record[ 'pid']);
			if(is_array($order_record)){
				$prod_record = array();
				$prod_record['alias'] = createAlias(15);
				$prod_record['status'] = '';
				$prod_record['user'] = $order_record['user'];
				$prod_record['last_timestamp'] = $order_record['last_timestamp'];
				$prod_record['prod_order'] = $order_record['prod_order']. '-1';
				$prod_record['transaction_code'] = $order_record['transaction_code'];
				$prod_record['sign_multiplier'] = $order_record['sign_multiplier'];
				$prod_record['org_code'] = $order_record['org_code'];
				$prod_record['order_nmbr'] = $order_record['order_nmbr'];
				$prod_record['client_id'] = $order_record['client_id'];
				$prod_record['order_line_id'] = $order_record['order_line_id'];
				$prod_record['time_slot'] = $order_record['time_slot'];
				$prod_record['ref_internal'] = $order_record['ref_internal'];
				$prod_record['sort'] = '5';
				$prod_record['date_indicator'] = 'F';
				$prod_record['lead_time'] = $record['lead_time'];
				$prod_record['lead_days'] = $record['lead_days'];
				$prod_record['opmerking'] = $record['tekst'];
				$prod_record['hoeveelheid'] = $record['hoeveelheid'];
				if (floatval($make_record['make_factor']) == 0){
					$make_record['make_factor'] = 1;
				}
				$prod_record['prod_bins'] = ceil(floatval($record['hoeveelheid']) * floatval($make_record['make_factor']) /
							floatval($location_record['capacity_bin']) * (100 + floatval($make_record['waste_perc'])) / 100);
				$prod_record['quantity_planned'] = $record['hoeveelheid'];
				$prod_record['prod_date'] = $record['date_start'];
				$prod_record['maak_product_id'] = $make_record['id'];
				$prod_record['type_bom'] = $make_record['type_bom'];
				$prod_record['location'] = $make_record['location'];
				$prod_record['eenheid'] = $make_record['eenheid'];
				$prod_record['omschrijving'] = $make_record['recept_naam'];
			
// create prod order record
				$db->insert('ctlg_prod_opdracht', $prod_record);
				return '';
			}
		}
		return '1';
}

// get Make data
	function getMakeData($db, $org_code, $id){
		$stmt = $db->prepare('SELECT * FROM ctlg_maak_producten WHERE id = ? AND org_code = ?');
		$stmt->bindValue(1, $id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;		
	}

// get Location data
	function getLocationData($db, $org_code, $id){
		$record = array();
		
		$stmt = $db->prepare('SELECT * FROM ctlg_locations WHERE id = ? AND org_code = ?');
		$stmt->bindValue(1, $id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;		
	}

// get product data
	function getProdData($db, $org_code, $id){
		$stmt = $db->prepare('SELECT * FROM ctlg_product_database WHERE id = ? AND org_code = ?');
		$stmt->bindValue(1, $id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;		
	}
	
// get ProdOrder on id
	function getProdOrder($db, $org_code, $id){
		$record = array();
		
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE id = ? AND org_code = ?');
		$stmt->bindValue(1, $id);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;		
	}

// get ProdOrder on make_id and production_date
	function getProdOrderDate($db, $org_code, $make_product_id, $date){
		$record = array();

// order_line_id < 0
// location = nvt
// prod_date = 
// maak_product_id
// status = '';
// type_bom = ST

		$stmt = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE org_code = ? AND maak_product_id = ? AND
					type_bom = ? AND prod_date = ? AND order_line_id < ? AND status = ?');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $make_product_id);
		$stmt->bindValue(3, 'ST');
		$stmt->bindValue(4, $date);
		$stmt->bindValue(5, 1);
		$stmt->bindValue(6, '');
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;		
	}

// check prodordernumber already exists
	function getProdOrderId($db, $org_code, $prod_order){
		$record = array();
		
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE prod_order = ? AND org_code = ?');
		$stmt->bindValue(1, $prod_order);
		$stmt->bindValue(2, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		
		return $record;		
	}

// set production order ready
	function setProdOrderReady($db, $org_code, $location, $date_select, $make_id){

		$record = array();
		$count = 0;
		$make_id_from = 0;
		$make_id_to = 0;		

// no processing on blank selection date or blank location
		if(intval($date_select) < 1 || intval($location) < 1){
			return $count;
		}

// set product_make_id selection range		
		$make_id_from = $make_id;
		$make_id_to = $make_id;		
		if(intval($make_id) < 1){
			$make_id_to = 999999999;
		}
		
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_opdracht WHERE  org_code = ? AND status < ? AND
							location = ? AND type_bom != ? AND date_start = ? AND
							maak_product_id >= ? AND maak_product_id <= ? 
							FOR UPDATE');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, '1');
		$stmt->bindValue(3, $location);
		$stmt->bindValue(4, 'PP');
		$stmt->bindValue(5, $date_select);
		$stmt->bindValue(6, $make_id_from);
		$stmt->bindValue(7, $make_id_to);
		$stmt->execute();
		$record = $stmt->fetch();
		while(is_array($record)){
// get make product data
			$make_record = getMakeData($db, $org_code, $record['maak_product_id']);
			
			if ($record['lot_code'] == ''){
				if ($make_record['lot_prefix'] != ''){
					$record['lot_code'] = createLotCode($db, $org_code, $make_record['lot_prefix']);
				}else{
					$record['lot_code'] = date('yz-H'). '-'. $record['id'];
				}
// create lot_code record
				addLotData($db, $org_code, $record['lot_code'], $make_record['product_db_id'],
					$record['id'], $record['opmerking']);
			}else{
// check lot_code existance
				$lot_record = checkLotCode($db, $org_code, $record['lot_code']);
				if (!is_array($lot_record)){
// create lot record
					addLotData($db, $org_code, $record['lot_code'], $make_record['product_db_id'],
						$record['id'], $record['opmerking']);
				}
			}

// create production transaction ready record
			addTransProd($db, $org_code, $record, $date_select);

// update production order
			$update_array = array();
			$where_array = array();
			$update_array['status'] = '9';
			$update_array['lot_code'] = $record['lot_code'];
			$where_array['id'] = $record['id'];
			$db->update('ctlg_prod_opdracht', $update_array, $where_array);
			$count++;
// next orderline
			$record = $stmt->fetch();
		}
		
		return $count;		
	}

// set production orderlines ready
	function setProdLinesReady($db, $org_code, $location, $date_select){

		$record = array();
		$count = 0;

// no processing on blank selection date or blank location
		if(intval($date_select) < 1 || intval($location) < 1){
			return $count;
		}
		
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_opdracht_rgls WHERE  org_code = ? AND status < ? AND
							location = ? AND bom_type != ? AND date_start = ? FOR UPDATE');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, '3');
		$stmt->bindValue(3, $location);
		$stmt->bindValue(4, 'S');
		$stmt->bindValue(5, $date_select);
		$stmt->execute();
		$record = $stmt->fetch();
		while(is_array($record)){
			$update_array = array();
			$where_array = array();
			
			$update_array['status'] = '3';
			$where_array['id'] = $record['id'];
			$db->update('ctlg_prod_opdracht_rgls', $update_array, $where_array);

			$count++;
// next orderline
			$record = $stmt->fetch();
		}
		return $count;		
	}
	
// create/update production order record from Harvest orders
	function createProdOrderHarvest($db, $org_code, $product_db_id, $date_prod, $prod_order_id, $quantity, $user_name, $prod_order){

		$prod_order_id = crtUpdProdOrder($db, $org_code, $product_db_id, $date_prod, $prod_order_id, $quantity, $user_name, $prod_order);
	
		return $prod_order_id;										
	}	
// create/update production order record from Harvest orders
	function createProdOrderWaste($db, $org_code, $product_db_id, $date_prod, $quantity, $user_name, $prod_order){

		$record = array();
		$sub_order = '';

// check production order already exists
		$record = getProdOrderId($db, $org_code, $prod_order);
		if (!is_array($record)){
			$record = array();
			$record['id'] = 0;
		}else{
			if ($record['status'] >= '1'){
				$record['id'] = 0;
				$sub_order = createAlias(3);
				$prod_order = $prod_order. '-'. $sub_order;
			}	
		}
// update/create production order		
		$prod_order_id = crtUpdProdOrder($db, $org_code, $product_db_id, $date_prod, $record['id'], $quantity, $user_name, $prod_order);
	
		return $prod_order_id;										
	}
	
// create extra production order record from waste during production at Robot(1) locations
	function crtUpdProdOrder($db, $org_code, $product_db_id, $date_prod, $prod_order_id, $quantity, $user_name, $prod_order){

		$prod_record = array();
		$sw_upd = '';

// get product database data
		$record_product = getProdData($db, $org_code, $product_db_id);
		if (!is_array($record_product) || intval($record_product['recept_id']) == 0){
			return 0;
		}

// get make product data
		$record = getMakeData($db, $org_code, $record_product['recept_id']);
		if(is_array($record)){
// get location info
			$location_record = getLocationData($db, $org_code, $record['location']);
			if (!is_array($location_record) || intval($location_record['capacity_bin']) == 0){
				$location_record['capacity_bin'] = 1;
			}
// check production order already exists
			if(intval($prod_order_id) > 0){
				$prod_record = getProdOrder($db, $org_code, $prod_order_id);
			}else{
				$prod_record = null;
			}

// check on production order on date already exists
			if(!is_array($prod_record)){
				$prod_record = getProdOrderDate($db, $org_code, $record['id'], $date_prod);
			}
			if(!is_array($prod_record)){
				$prod_record = array();
				$prod_record['alias'] = createAlias(15);
				$prod_record['org_code'] = $org_code;
				$prod_record['status_order'] = '1';
				$prod_record['maak_product_id'] = $record['id'];
				$prod_record['tstamp'] = strtotime(date('Y-m-d'));
				$prod_record['prod_order'] = $prod_order;
				$prod_record['omschrijving'] = $record['recept_naam'];
				$prod_record['eenheid'] = $record['eenheid'];
				$prod_record['transaction_code'] = 'P1';
				$prod_record['sign_multiplier'] = 1;
				$prod_record['type_bom'] = 	$record['type_bom'];
				$prod_record['date_indicator'] = 'F';			// finish date
				$prod_record['location'] = $record['location'];
				$prod_record['lead_days'] = $record['lead_days'];
				$prod_record['lead_time'] = $record['lead_time'];
				$prod_record['ready_ind'] = $record['ready_ind'];
				$prod_record['prod_date'] = $date_prod;
				$prod_record['date_start'] = $date_prod;
				$prod_record['time_slot'] = '';
				$prod_record['sort'] = '5';
				$prod_record['hoeveelheid'] = 0;
				$prod_record['opmerking'] = '';
// check on lot_code needed
				if($record['lot_prefix'] != ''){
					$system_lot = 'lot_number_'. $record['lot_prefix'];
					$lot_nmbr = get_system_nmbr_2($system_lot, $db, $org_code, '2', '001');
					$prod_record['lot_code'] = $record['lot_prefix']. $lot_nmbr;
				}
				$sw_upd = 'A';
			}else{
// check production order already finished, then return
				if($prod_record['status'] >= '1'){
					return $prod_record['id'];
				}
				$sw_upd = 'U';
			}

// create production order
			$prod_record['last_timestamp'] = strtotime(date('Y-m-d'));
			$prod_record['user'] = $user_name;
			$prod_record['hoeveelheid'] = floatval($prod_record['hoeveelheid']) + $quantity;
			if (floatval($record['make_factor']) == 0){
				$record['make_factor'] = 1;
			}
			$prod_record['prod_bins'] = ceil(floatval($prod_record['hoeveelheid']) * floatval($record['make_factor']) /
					floatval($location_record['capacity_bin']) * (100 + floatval($make_record['waste_perc'])) / 100);
			$prod_record['quantity_planned'] = $prod_record['hoeveelheid'];

			if($sw_upd == 'A'){
				$db->insert('ctlg_prod_opdracht', $prod_record);
				$prod_order_id = $db->lastInsertId();
			}else{
				$where_array = array();
				$where_array['id'] = $prod_record['id'];
				$db->update('ctlg_prod_opdracht', $prod_record, $where_array);
				$prod_order_id = $prod_record['id'];
// create lot record
				if($record['lot_prefix'] != ''){
					addLotData($db, $org_code, $prod_record['lot_code'], $record['product_db_id'],
						$prod_order_id, $prod_record['opmerking']);
				}
			}
		}		
		return $prod_order_id;										
	}
	
?>
