<?php

return array(
	'label' => array(
		'Zentrierter Bereich Anfang',
		'Erzeugt einen zentrierten Inhaltsbereich',
	),
	'types' => array('content', 'module'),
	'standardFields' => array('cssID', 'space'),
	'wrapper' => array(
		'type' => 'start',
	),
	'fields' => array(
		'borderTop' => array(
			'label' => array('Rahmen oben', 'Erzeugt vor dem Element eine Linie.'),
			'inputType' => 'checkbox',
			'eval' => array('tl_class' => 'w50'),
		),
		'borderBottom' => array(
			'label' => array('Rahmen unten', 'Erzeugt nach dem Element eine Linie.'),
			'inputType' => 'checkbox',
			'eval' => array('tl_class' => 'w50'),
		),
		'borderTopColor' => array(
			'label' => array('Rahmenfarbe oben', 'Lassen Sie dieses Feld leer um die Standardfarbe zu verwenden.'),
			'inputType' => 'text',
			'eval' => array(
				'colorpicker' => true,
				'tl_class' => 'w50',
			),
		),
		'borderBottomColor' => array(
			'label' => array('Rahmenfarbe unten', 'Lassen Sie dieses Feld leer um die Standardfarbe zu verwenden.'),
			'inputType' => 'text',
			'eval' => array(
				'colorpicker' => true,
				'tl_class' => 'w50',
			),
		),
		'borderTopWidth' => array(
			'label' => array('Rahmenbreite oben', 'Lassen Sie dieses Feld leer um die Standardbreite zu verwenden.'),
			'inputType' => 'inputUnit',
			'options' => array('px', '%', 'em', 'rem', 'ex', 'pt', 'pc', 'in', 'cm', 'mm'),
			'eval' => array(
				'includeBlankOption' => true,
				'rgxp' => 'digit_auto_inherit',
				'tl_class' => 'w50',
			),
		),
		'borderBottomWidth' => array(
			'label' => array('Rahmenbreite unten', 'Lassen Sie dieses Feld leer um die Standardbreite zu verwenden.'),
			'inputType' => 'inputUnit',
			'options' => array('px', '%', 'em', 'rem', 'ex', 'pt', 'pc', 'in', 'cm', 'mm'),
			'eval' => array(
				'includeBlankOption' => true,
				'rgxp' => 'digit_auto_inherit',
				'tl_class' => 'w50',
			),
		),
		'backgroundImage' => array(
			'label' => array('Hintergrundbild oder -Video', 'Wählen Sie ein Bild oder mehrere Videodateien aus.'),
			'inputType' => 'fileTree',
			'eval' => array(
				'tl_class' => 'clr',
				'multiple' => true,
				'fieldType' => 'checkbox',
				'filesOnly' => true,
				'extensions' => \Config::get('validImageTypes') . ',mp4,webm,ogv,ogg',
			),
		),
		'backgroundImageSize' => array(
			'label' => array('Bildbreite und Bildhöhe', ''),
			'inputType' => 'imageSize',
			'options' => \System::getImageSizes(),
			'reference' => &$GLOBALS['TL_LANG']['MSC'],
			'eval' => array(
				'rgxp' => 'digit',
				'tl_class' => 'w50',
				'includeBlankOption' => true,
			),
		),
		'backgroundSize' => array(
			'label' => array('Hintergrundbildgröße', ''),
			'inputType' => 'select',
			'options' => array(
				'' => 'Beschnitten',
				'contain' => 'Proportional',
				'100% 100%' => 'Verzerrt',
				'auto auto' => 'Originalgröße',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'backgroundPosition' => array(
			'label' => array('Hintergrundposition', 'Nicht mit Parallax-Effekt kombinierbar'),
			'inputType' => 'select',
			'options' => array(
				'' => '-',
				'0 0' => 'Links | Oben',
				'50% 0' => 'Mitte | Oben',
				'100% 0' => 'Rechts | Oben',
				'0 50%' => 'Links | Mitte',
				'50% 50%' => 'Mitte | Mitte',
				'100% 50%' => 'Rechts | Mitte',
				'0 100%' => 'Links | Unten',
				'50% 100%' => 'Mitte | Unten',
				'100% 100%' => 'Rechts | Unten',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'colorVariation' => array(
			'label' => array('Vordefinierte Hintergrundfarbe', 'Eine der vordefinierten Farben als Hintergrund verwenden. Die Farben lassen sich mit dem Theme Assistant, CSS oder Sass anpassen.'),
			'inputType' => 'select',
			'options' => array(
				'' => '-',
				'-highlight-color' => 'Highlight-Farbe',
				'-background-color-1' => 'Hintergrundfarbe 1 (Dunkel)',
				'-background-color-2' => 'Hintergrundfarbe 2 (Hell)',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'backgroundColor' => array(
			'label' => array('Eigene Hintergrundfarbe', 'Überschreibt die vordefinierte Einstellung.'),
			'inputType' => 'text',
			'eval' => array(
				'colorpicker' => true,
				'tl_class' => 'w50',
			),
		),
		'backgroundVariation' => array(
			'label' => array('Hintergrundeffekt', ''),
			'inputType' => 'select',
			'options' => array(
				'' => '-',
				'-background-parallax' => 'Parallax',
				'-background-mousemove' => 'Mit der Maus bewegend',
				'-background-mousemove-inverted' => 'Entgegen der Maus bewegend',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'colorInverted' => array(
			'label' => array('Textfarbe invertieren', 'Helle Textfarbe für dunkle Hintergründe und Fotos.'),
			'inputType' => 'checkbox',
			'eval' => array(
				'tl_class' => 'w50 m12',
			),
		),
		'height' => array(
			'label' => array('Mindesthöhe erzwingen', 'Setzt die Mindesthöhe des Bereiches auf einen der im CSS definierten Werte.'),
			'inputType' => 'select',
			'options' => array(
				'' => '-',
				'-small' => 'Schmal',
				'-medium' => 'Mittel',
				'-large' => 'Hoch',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'fullwidth' => array(
			'label' => array('Content-Fullwidth', 'Inhalt über die gesamte Breite anzeigen.'),
			'inputType' => 'checkbox',
			'eval' => array(
				'tl_class' => 'w50 m12',
			),
		),
	),
);
