<?php

return array(
	'label' => array(
		'Feature-Box',
		'Erzeugt einen Bereich mit Text, Bild/Video und Hintergrundbild',
	),
	'types' => array('content'),
	'standardFields' => array('cssID', 'headline'),
	'fields' => array(
		'image' => array(
			'label' => array('Feature-Bild oder -Video', 'Wählen Sie ein Bild oder mehrere Videodateien aus.'),
			'inputType' => 'fileTree',
			'eval' => array(
				'multiple' => true,
				'fieldType' => 'checkbox',
				'filesOnly' => true,
				'extensions' => \Config::get('validImageTypes') . ',mp4,webm,ogv,ogg',
			),
		),
		'imageSize' => array(
			'label' => array('Bildbreite und Bildhöhe', ''),
			'inputType' => 'imageSize',
			'options' => \System::getImageSizes(),
			'reference' => &$GLOBALS['TL_LANG']['MSC'],
			'eval' => array(
				'rgxp' => 'digit',
				'tl_class' => 'w50',
				'includeBlankOption' => true,
			),
		),
		'imagePosition' => array(
			'label' => array('Bildposition', ''),
			'inputType' => 'select',
			'options' => array(
				'-image-right -vertical-centered -image-after-text' => 'Rechts zentriert',
				'-image-right -image-top' => 'Rechts oben',
				'-image-right -image-bottom' => 'Rechts unten',
				'-vertical-centered -image-left' => 'Links zentriert',
				'-image-left -image-top' => 'Links oben',
				'-image-left -image-bottom' => 'Links unten',
				'-image-centered' => 'Oben zentriert',
				'-image-centered -image-after-text' => 'Unten zentriert',
				'-image-centered -vertical-centered -no-image' => 'Zentriert ohne Bild',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'imageAnimationType' => array(
			'label' => array('Bild Animation', 'Art der Animation'),
			'inputType' => 'select',
			'options' => array(
				'not-animated' => 'Keine',
				'-fade' => 'Einblenden',
				'-move' => 'Bewegen',
				'-move -fade' => 'Einblenden + Bewegen',
			),
			'eval' => array('tl_class' => 'w50 clr'),
		),
		'imageAnimationDirection' => array(
			'label' => array('Bild Animationsrichtung', 'Bewegungsrichtung der Animation'),
			'inputType' => 'select',
			'options' => array(
				'-move-left' => 'Nach links',
				'-move-right' => 'Nach rechts',
				'-move-top' => 'Nach oben',
				'-move-bottom' => 'Nach unten',
			),
			'eval' => array(
				'tl_class' => 'w50',
				'includeBlankOption' => true,
			),
		),
		'imageRounded' => array(
			'label' => array('Bild abrunden', 'Stellt das Bild als Kreis dar, sofern quadratisch.'),
			'inputType' => 'checkbox',
			'eval' => array('tl_class' => 'w50 m12'),
		),
		'text' => array(
			'label' => array('Text', ''),
			'inputType' => 'textarea',
			'eval' => array(
				'rte' => 'tinyMCE',
				'tl_class' => 'clr',
			),
		),
		'textAnimationType' => array(
			'label' => array('Text Animation', 'Art der Animation'),
			'inputType' => 'select',
			'options' => array(
				'not-animated' => 'Keine',
				'-fade' => 'Einblenden',
				'-move' => 'Bewegen',
				'-move -fade' => 'Einblenden + Bewegen',
			),
			'eval' => array('tl_class' => 'w50 clr'),
		),
		'textAnimationDirection' => array(
			'label' => array('Text Animationsrichtung', 'Bewegungsrichtung der Animation'),
			'inputType' => 'select',
			'options' => array(
				'-move-left' => 'Nach links',
				'-move-right' => 'Nach rechts',
				'-move-top' => 'Nach oben',
				'-move-bottom' => 'Nach unten',
			),
			'eval' => array(
				'tl_class' => 'w50',
				'includeBlankOption' => true,
			),
		),
		'linkIcon' => array(
			'label' => array('Link-Icon', ''),
			'inputType' => 'rocksolid_icon_picker',
			'eval' => array('tl_class' => 'clr', 'iconFont' => 'files/tao/fonts/rocksolid-icons.svg'),
		),
		'linkLabel' => array(
			'label' => array('Button-Text', ''),
			'inputType' => 'text',
			'eval' => array('tl_class' => 'w50'),
		),
		'linkUrl' => array(
			'label' => array('Button-URL', 'Beispiele: {{link_url::seitenalias}} (Alias, ID oder anderer Inserttag), http://example.com'),
			'inputType' => 'url',
			'eval' => array('tl_class' => 'w50'),
		),
		'newWindow' => array(
			'label' => $GLOBALS['TL_LANG']['MSC']['target'],
			'inputType' => 'checkbox',
			'eval' => array('tl_class' => 'clr'),
		),
		'linkVariation' => array(
			'label' => array('Buttonvariante', ''),
			'inputType' => 'select',
			'options' => array(
				'' => 'Standard',
				'-secondary' => 'Button 2',
				'-tertiary' => 'Button 3',
				'-quaternary' => 'Button 4',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'imageLink' => array(
			'label' => array('Bild verlinken', 'Macht die ausgewählte Grafik „klickbar“.'),
			'inputType' => 'checkbox',
			'eval' => array('tl_class' => 'w50 m12'),
		),
		'headlineSize' => array(
			'label' => array('Headline-Größe', 'Schriftgröße der Headline.'),
			'inputType' => 'select',
			'options' => array(
				'' => 'Standard',
				'-small' => 'Klein',
				'-medium' => 'Mittel',
				'-large' => 'Groß',
				'-super-size' => 'Supersize',
			),
			'eval' => array('tl_class' => 'w50'),
		),
		'headlineDropshadow' => array(
			'label' => array('Überschrift mit Schlagschatten', 'Fügt der Überschrift einen leichten Schlagschatten hinzu.'),
			'inputType' => 'checkbox',
			'eval' => array('tl_class' => 'w50 m12'),
		),
		'height' => array(
			'label' => array('Mindesthöhe erzwingen', 'Setzt die Mindesthöhe des Bereiches auf einen der im CSS definierten Werte.'),
			'inputType' => 'select',
			'options' => array(
				'' => '-',
				'-small' => 'Schmal',
				'-medium' => 'Mittel',
				'-large' => 'Hoch',
			),
			'eval' => array('tl_class' => 'w50'),
		),
	),
);
