<?php

	require('organization.php');

// function crate alias for records
	require('create_alias.php');


// create stockplanning from sales order lines
	function createStockPlanSales($db, $org_code, $week_ref, $produce_next_day_hours){

		$none_work_days = array();

// determine none-working days
		$none_work_days = noneWorkDays($db, $org_code);

		processPlan($db, $org_code, $week_ref, $none_work_days, $produce_next_day_hours);
// update with cumulative stock availabillity
		calcSumDayProduct($db, $org_code, 0);
		
		return;
	}

// update stockplanning from new/updated sales order line
	function updProdSalesPlan($db, $org_code, $plu_id, $quantity, $date){
		
		$bin_capacity = 45;
		$none_work_days = array();

// determine none-working days
		$none_work_days = noneWorkDays($db, $org_code);

		saleDayPlan($db, $org_code, $plu_id, $date, $quantity, 0, 0, $bin_capacity);
		
		return;
	}


// get prod day plan record
	function getDayPlan($db, $org_code, $product_db_id, $date){

		$stmt = $db->prepare('SELECT * FROM ctlg_prod_day_plan WHERE org_code = ? AND
						product_db_id = ? AND date = ?');	
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $product_db_id);
		$stmt->bindValue(3, strtotime(date('Y-m-d', $date)));
		$stmt->execute();
		$record = $stmt->fetch();		
		
		return $record;
	}

// get prod day plan record
	function getProdId($db, $org_code, $plu_id){

		$stmt = $db->prepare('SELECT * FROM ctlg_product_database WHERE org_code = ? AND
						plu_id = ?');	
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $plu_id);
		$stmt->execute();
		$record = $stmt->fetch();		
		
		return $record;
	}

// create day planning record
	function saleDayPlan($db, $org_code, $plu_id, $date, $quantity, $date_ref, $sold_ref, $bin_capacity){

		$where_array = array();
		$product_ref = 0;
		$multiplier = 1;

// get reference product_id		
		$prod_db_record = getProdId($db, $org_code, $plu_id);

		$product_ref = $prod_db_record['product_ref'];
		if ($product_ref <= 0){
			$product_ref = intval($prod_db_record['id']);
		}else{
			$multiplier = $prod_db_record['ref_multiplier']; 
		}

// multiply by to get product refence unit
		$quantity = $quantity * $multiplier;
		$sales_soft = $sold_ref * $multiplier;
		
		$record = getDayPlan($db, $org_code, $product_ref, $date);
		if(!is_array($record)){
			$record = array();
			$record['alias'] = createAlias(15);
			$record['date'] = strtotime(date('Y-m-d', $date));
			$record['product_db_id'] = $product_ref;
			$record['plan_sale_units'] = max(0, $quantity);
			$record['plan_sale_soft_bins'] = ceil($sales_soft / $bin_capacity);
			$record['plan_sale_bins'] = ceil($quantity / $bin_capacity);
			$record['plan_prod_units'] = 0;
			$record = calcStockLevels($record);
// Create plan record			
			$db->insert('ctlg_prod_day_plan', $record);
		}else{
			$record['plan_sale_units'] = floatval($record['plan_sale_units']) + $quantity;
			$record['plan_sale_bins'] = floatval($record['plan_sale_bins']) + ceil($quantity / $bin_capacity);
			$record['plan_sale_soft_bins'] = floatval($record['plan_sale_soft_bins']) + ceil($sales_soft / $bin_capacity);
			$record = calcStockLevels($record);
			$where_array['id'] = $record['id'];
// update plan record with sales data			
			$db->update('ctlg_prod_day_plan', $record, $where_array);
		}
		return;
	}

// update plan record with sales forecast
	function updProdPlan($db, $org_code, $product_db_id, $date, $quantity, $bin_capacity){

		$where_array = array();
		$quantity = ceil($quantity / $bin_capacity);
		
		$record = getDayPlan($db, $org_code, $product_db_id, $date);
		if(!is_array($record)){
			$record = array();
			$record['org_code']= $org_code;
			$record['alias'] = createAlias(15);
			$record['date'] = strtotime(date('Y-m-d', $date));
			$record['product_db_id'] = $product_db_id;
			$record['plan_sale_soft_bins'] = $quantity;
			$record['plan_prod_units'] = 0;
			$record = calcStockLevels($record);
// Create plan record			
			$db->insert('ctlg_prod_day_plan', $record);
		}else{
			$record['plan_sale_soft_bins'] = max(0, $quantity - floatval($record['plan_sale_soft_bins']) + floatval($record['plan_sale_bins']));
			$where_array['id'] = $record['id'];
// update plan record with sales data			
			$db->update('ctlg_prod_day_plan', $record, $where_array);			
		}
			return;
	}

	
	function calcStockLevels($record){
		$units = max(0, floatval($record['plan_prod_units']) - floatval($record['plan_sale_units']));
		$record['stock_fust_12'] = floor($units / 12);
		$record['stock_fust_10'] = floor($units / 10);
		$record['stock_fust_9'] = floor($units / 9);
		$record['stock_fust_8'] = floor($units / 8);
		$record['stock_fust_6'] = floor($units / 6);
		$record['stock_fust_3'] = floor($units / 3);		
		$record['stock_kg'] = floor($units / 4);		
		
		return $record;
	}

// calculate sum per day
	function calcSumDayProduct($db, $org_code, $product_db_id){

		$stock_cum = 0;
		$record = array();
		$update_array = array();
		$where_array = array();
		
		$bin_capacity =  45;
		$bin_multiplier = 4;

		if (intval($product_db_id) == 0){
			$prod_sel = 'product_db_id = product_db_id';
		}else{
			$prod_sel = 'product_db_id = "'. $product_db_id. '"';
		}		
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_day_plan WHERE org_code = ? AND '. $prod_sel. ' ORDER BY product_db_id, date FOR UPDATE');	
		$stmt->bindValue(1, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		while (is_array($record)){
			$v_date = $record['date'];
			$v_product_db_id = $record['product_db_id'];
// calculatue delta additions			
			$stock_cum = $stock_cum + floatval($record['plan_prod_units']) - floatval($record['plan_sale_units']);
			$stock_cum_plan = $stock_cum_plan + floatval($record['plan_prod_units']) - floatval($record['plan_sale_units']);

			$where_array['id'] = $record['id'];
			$update_array['stock_cum'] = max(0, $stock_cum);
			if (floatval($stock_cum_plan) < 0){
				$update_array['prod_plus'] = ceil(-1 * $stock_cum_plan / $bin_capacity / $bin_multiplier) * $bin_multiplier;
				$stock_cum_plan = $stock_cum_plan + ($update_array['prod_plus'] * $bin_capacity);
			}else{
				$update_array['prod_plus'] = 0;
			}
			$db->update('ctlg_prod_day_plan', $update_array, $where_array);

			$record = $stmt->fetch();
			
			if (!is_array($record) || $v_product_db_id != $record['product_db_id']) {
				$stock_cum = 0;
			}
		}
		return;
	}

// empty dayplan before actual date
	function initDayPlanSale($db, $org_code, $date){
		
		$where_array = array();
		$update_array = array();
		
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_day_plan WHERE org_code = ? ORDER BY date FOR UPDATE');	
		$stmt->bindValue(1, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		while (is_array($record)){
			$where_array['id'] = $record['id'];
// delete row or update record
			if (intval($record['date']) < $date){
				$db->delete('ctlg_prod_day_plan', $where_array);				
			}else{
				$update_array['plan_sale_units'] = 0;
				$update_array['plan_sale_bins'] = 0;
				$update_array['plan_sale_soft_bins'] = 0;
				$db->update('ctlg_prod_day_plan', $update_array, $where_array);
			}
// next row
			$record = $stmt->fetch();
		}
		return;
	}

//  function, get date before non-working days and not on saturday or sunday
	function getProdDate($none_work_days, $date){
// determine first date before none-working day
// 6=saturday, 7=sunday
		for ($i=1; $i<5; $i++){
			$date_new = $date - $i * 86400;
			if (date('N',$date_new) < 6 && array_search($date_new, $none_work_days) == false){
				return $date_new;
			}
		}
		return $date;
	}

// check non-working day
	function noneWorkDays($db, $org_code){

		$days = array();
		$i1 = 0;

		$stmt = $db->prepare('SELECT * FROM ctlg_kenmerken_tabel WHERE org_code = ? AND
				systeem = ? AND var1 != ?');	
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, 'feestdagen');
		$stmt->bindValue(3, '');
		$stmt->execute();
		$record = $stmt->fetch();
		while (is_array($record)){		
			$days[$i1] = strtotime($record['var1']);
			$i1++;
			$record = $stmt->fetch();	
		}
		return $days;
	}

// get picklist quantity in delivery, not yet completely processed
	function getPickDelivery($db, $org_code, $order_line_id){
		$in_delivery = 0;

// get picklist record
		$stmt = $db->prepare('SELECT * FROM ctlg_picklist WHERE
					org_code = ? AND order_rgl_id = ?');	
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $order_line_id);
		$stmt->execute();
		$record = $stmt->fetch();	
		while (is_array($record)){
			$in_delivery = $in_delivery + floatval($record['hvh_picked']);
			$record = $stmt->fetch();
		}
		return $in_delivery;
	}
	
// calculate sale x days before
function getSaleRef($db, $org_code, $plu_id, $client_id, $date){

	$date = strtotime(date('Y-m-d', $date));

	$sold = 0;
	if (intval($client_id) == 0){
		$client_sel = 'client_id = client_id';
	}else{
		$client_sel = 'client_id = "'. $client_id. '"';
	}

	$stmt = $db->prepare('SELECT * FROM ctlg_product_revenue WHERE org_code = ? AND date_sale = ? AND 
				 plu_id = ? AND '. $client_sel );	
	$stmt->bindValue(1, $org_code);
	$stmt->bindValue(2, $date);
	$stmt->bindValue(3, $plu_id);
//	$stmt->bindValue(4, $client_id);
	$stmt->execute();
	$record = $stmt->fetch();
	while (is_array($record)){
// accumulate sales quantities		
		$sold = $sold + floatval($record['quantity']);
		$record = $stmt->fetch();
	}
	return $sold;
}

// process and rebuild sales stock planning
function processPlan($db, $org_code, $week_ref, $none_work_days, $produce_next_day_hours){
// current date is starting date
	$date_now = strtotime(date('Y-m-d'));

	$where_array = array();
	$v_plu_id = '';
	$v_lever_datum = '';
	$v_klant_id = '';
	$sales = 0;
	$sold_ref = 0;
	
	$location_harvest =  15;
	$bin_capacity = 45;
		
// Empty table until date now
	initDayPlanSale($db, $org_code, $date_now);

	$quantity = 0;
	$pick_delivered = 0;

// rebuild table with actual sales data
	$stmt = $db->prepare('SELECT * FROM ctlg_bestelregels WHERE org_code = ? AND lever_datum >= ?
				ORDER BY plu_id, lever_datum, klant_id, delivery_time');	
	$stmt->bindValue(1, $org_code);
	$stmt->bindValue(2, $date_now);
	$stmt->execute();
	$record = $stmt->fetch();
	while (is_array($record)){
		$v_plu_id = $record['plu_id'];
		$v_lever_datum = $record['lever_datum'];
		$v_klant_id = $record['klant_id'];
		if (intval($record['delivery_time']) < ($produce_next_day_hours * 3600)){		// delivery before 10:00, harvest day before
			$v_lever_datum = getProdDate($none_work_days, $v_lever_datum);
		}
// calculate remaining delivery
		$pick_delivered = getPickDelivery($db, $org_code, $record['id']);
		$quantity = $quantity + floatval($record['hoeveelheid']) - floatval($record['aantal_geleverd']) - $pick_delivered;

// get next sales record
		$record = $stmt->fetch();

// calculate sold last reference period
		if (!is_array($record) || $record['plu_id'] != $v_plu_id || $record['lever_datum'] != $v_lever_datum ||
						$record['klant_id'] != $v_klant_id){
			$date_ref = $v_lever_datum - ($week_ref * 7 * 86400);
			$sales = getSaleRef($db, $org_code, $v_plu_id, $v_klant_id, $date_ref);
			$sold_ref = $sold_ref + $sales;
		}
// update planning
		if (!is_array($record) || $record['plu_id'] != $v_plu_id || $record['lever_datum'] != $v_lever_datum){
			if (intval($v_lever_datum) >= $date_now){
				saleDayPlan($db, $org_code, $v_plu_id, $v_lever_datum, $quantity, $date_ref, $sold_ref, $bin_capacity);
			}
			$quantity = 0;
			$sold_ref = 0;
		}
	}

// add sales forecast to plan
// calculate total soft sales on reference dates in periode
	$date_start = $date_now - ($week_ref * 7 * 86400);
	$date_end = $date_start + (7 * 86400);

	$sold_total = 0;
	$v_base_id = 0;
	$v_date_sale = 0;

	$stmt_rev = $db->prepare('SELECT * FROM ctlg_product_revenue WHERE org_code = ? AND date_sale >= ? AND
				date_sale <= ? ORDER BY base_product_id, date_sale');
	$stmt_rev->bindValue(1, $org_code);
	$stmt_rev->bindValue(2, $date_start);
	$stmt_rev->bindValue(3, $date_end);
	$stmt_rev->execute();
	$rev_record = $stmt_rev->fetch();
	while (is_array($rev_record)){
		$v_base_product_id = $rev_record['base_product_id'];
		$v_date_sale = $rev_record['date_sale'];
		$sold_total = $sold_total + (floatval($rev_record['quantity']) * floatval($rev_record['base_multiplier']));

// get next record
		$rev_record = $stmt_rev->fetch();

		if (!is_array($rev_record) || $v_base_product_id  != $rev_record['base_product_id'] ||
					$v_date_sale != $rev_record['date_sale']){
// update production plan data
			$date_plan = $v_date_sale + ($week_ref * 7 * 86400);
			updProdPlan($db, $org_code, $v_base_product_id, $date_plan, $sold_total, $bin_capacity);
			
			$sold_total = 0;
		}
	}
	return;
}


// processing for production planning
// init day planning
	function initDayPlan($db, $org_code, $date_today){

		$where_array = array();
		
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_day_plan WHERE
				org_code = ? ORDER BY date FOR UPDATE');
		$stmt->bindValue(1, $org_code);
		$stmt->execute();
		$record = $stmt->fetch();
		while (is_array($record)){
			$where_array['id'] = $record['id'];
			if (intval($record['date']) < $date_today){
// delete old dates
				$db->delete('ctlg_prod_day_plan', $where_array);
			}else{
// init dates for harvest data				
				$record['plan_prod_units'] = 0;
				$record['plan_prod_bins'] = 0;
				$record['stock_fust_3'] = 0;
				$record['stock_fust_6'] = 0;
				$record['stock_fust_8'] = 0;
				$record['stock_fust_9'] = 0;
				$record['stock_fust_10'] = 0;
				$record['stock_fust_12'] = 0;
				$record['stock_kg'] = 0;
				$record['stock_cum'] = 0;
				$record['prod_plus'] = $record['plan_sale_bins'];
				
				$db->update('ctlg_prod_day_plan', $record, $where_array);
			}
// Next plan record
			$record = $stmt->fetch();			
		}
		return;
	}

// create production planning records
	function updProdPlanning($db, $org_code, $location){

		$date_today = strtotime(date('Y-m-d'));

// set production planning to zero
		initDayPlan($db, $org_code, $date_today);

		$last_position = array();
		$last_position['id'] = 0;
		$last_position['done'] = 0;
		
		$v_location_sub_from = '';
		
// add production planning to stokplanning
// read all harvest planning record starting today
		$stmt = $db->prepare('SELECT * FROM ctlg_prod_loc_move_orders WHERE org_code = ? AND 
					location_from = ? AND date_transaction >= ? ORDER BY location_sub_from, date_transaction');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $location);
		$stmt->bindValue(3, $date_today);
		$stmt->execute();
		$record = $stmt->fetch();
		while (is_array($record)){
			$v_location_sub_from = $record['location_sub_from'];
// update/create stockplanning records
			$quantity_left = floatval($record['quantity']) - floatval($record['quantity_done']);
			$last_position = createHarvestPlanOrders($db, $org_code, intval($record['date_transaction']), $record['location_from'],
					$record['location_sub_from'], $quantity_left, $last_position['done'], $last_position['id']);

			$record = $stmt->fetch();
			if ($v_location_sub_from != $record['location_sub_from']){
				$last_position['id'] = 0;
				$last_position['done'] = 0;	
			}
		}
		return;
	}

// create Harvest orders
	function createHarvestPlanOrders($db, $org_code, $date, $location, $location_sub, $quantity_harvest, $quantity_start, $last_id){

		$date = strtotime(date('Y-m-d', $date));
		
		$quantity = 0;
		$last_position = array();
		$quantity_rest = $quantity_harvest;

		$last_id = intval($last_id);

		$stmt = $db->prepare('SELECT * FROM ctlg_prod_location_status WHERE
				org_code = ? AND location = ? AND location_sub = ? AND id >= ? ORDER BY date, time, id');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $location);
		$stmt->bindValue(3, $location_sub);
		$stmt->bindValue(4, $last_id);
		$stmt->execute();
		$record = $stmt->fetch();		
		while (is_array($record) && $quantity_rest > 0){
			
			$v_product_db_id = $record['product_db_id'];
			$quantity_available = floatval($record['quantity']) - $quantity_start;

			$quantity_start = 0;
			if ($quantity_available < $quantity_rest){
				$quantity = $quantity + $quantity_available;
				$last_position['done']  = $quantity_available;
			}else{
				$quantity = $quantity + $quantity_rest;
				$last_position['done'] = $quantity_rest;
			}
			$quantity_rest = $quantity_harvest - $quantity;
			$last_position['id'] = $record['id'];

// next record			
			$record = $stmt->fetch();
			
			if (!is_array($record) || $v_product_db_id != $record['product_db_id'] || $quantity_rest <= 0){
				
// upate day planning record
				if ($quantity > 0){
					updateDayPlan($db, $org_code, $date, $v_product_db_id, $quantity);					
				}
				$quantity_harvest = $quantity_harvest - $quantity;				
				$quantity = 0;
			}
		}

		return $last_position;		
	}

// create harvest planning
	function updateDayPlan($db, $org_code, $date, $product_db_id, $quantity){
		
		$record = array();
		$where_array = array();

		$stmt = $db->prepare('SELECT * FROM ctlg_prod_day_plan WHERE
				org_code = ? AND product_db_id = ? AND date = ? FOR UPDATE');
		$stmt->bindValue(1, $org_code);
		$stmt->bindValue(2, $product_db_id);
		$stmt->bindValue(3, $date);
		$stmt->execute();
		$record = $stmt->fetch();
		if (!is_array($record)){
// init dates for harvest data
			$record = array();
			$record['alias'] = createAlias(15);
			$record['product_db_id'] = $product_db_id;
			$record['date'] = $date;
			$record['org_code'] = $org_code;
			$record['plan_sale_units'] = 0;
			$record['plan_sale_bins'] = 0;
			$record['plan_sale_soft_bins'] = 0;
			$sw_upd = 'A';
		}else{
			$sw_upd = 'U';
		}

		$record['plan_prod_units'] = floatval($record['plan_prod_units']) + ($quantity * 45);
		$record['plan_prod_bins'] = floatval($record['plan_prod_bins']) + $quantity;
		$record = calcStockLevels($record);
		
		$record['stock_cum'] = 0;
		$record['prod_plus'] = max(0, floatval($record['plan_sale_soft_bins']) - floatval($record['plan_sale_bins']) -
					floatval($record['plan_prod_bins']));

// update/create planning record
		if ($sw_upd == 'U'){
			$where_array['id'] = $record['id'];
			$db->update('ctlg_prod_day_plan', $record, $where_array);
		}else{
			$db->insert('ctlg_prod_day_plan', $record);
		}
		
		return;
	}


?>
