<?php

/**
 * Extension for Contao 4
 *
 * @copyright  Softleister 2018
 * @author     Softleister <info@softleister.de>
 * @package    contao-message-jobs-bundle
 * @licence    LGPL-3.0+
 */

/**
 * Notification Center
 */
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['msg_jobs']          = 'Message jobs';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['msg_jobs_transmit'] = array('Message jobs', 'Output of a message job');

$GLOBALS['TL_LANG']['tl_nc_notification']['type']['catalog_manager'] = 'Catalog Manager';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['ctlg_entity_status_insert'] = [ 'Frontend Editing: Create', 'This notification type can be sent when the entity is created.' ];
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['ctlg_entity_status_update'] = [ 'Frontend Editing: Update', 'This notification type can be sent when the entity is updated.' ];
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['ctlg_entity_status_delete'] = [ 'Frontend Editing: Delete', 'This notification type can be sent when the entity is deleted.' ];
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['ctlg_entity_status_duplicate'] = [ 'Frontend Editing: Duplicate', 'This notification type can be sent when the entity is duplicated.' ];

// system/modules/notification_center/languages/en/tl_nc_notification.xlf
$GLOBALS['TL_LANG']['tl_nc_notification']['title'][0] = 'Title';
$GLOBALS['TL_LANG']['tl_nc_notification']['title'][1] = 'Please enter a title for this notification.';
$GLOBALS['TL_LANG']['tl_nc_notification']['type'][0] = 'Type';
$GLOBALS['TL_LANG']['tl_nc_notification']['type'][1] = 'Please select a type for this notification.';
$GLOBALS['TL_LANG']['tl_nc_notification']['flatten_delimiter'][0] = 'Delimiter for lists';
$GLOBALS['TL_LANG']['tl_nc_notification']['flatten_delimiter'][1] = 'When list values (array values) are submitted, the Notification Center flattens them automatically by using a comma (",") by default. Change this here if you like.';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['email'] = 'Standard eMail gateway';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['file'] = 'Write to file';
$GLOBALS['TL_LANG']['tl_nc_notification']['new'][0] = 'New notification';
$GLOBALS['TL_LANG']['tl_nc_notification']['new'][1] = 'Create a new notification.';
$GLOBALS['TL_LANG']['tl_nc_notification']['edit'][0] = 'Manage notifications';
$GLOBALS['TL_LANG']['tl_nc_notification']['edit'][1] = 'Manage messages for notification ID %s.';
$GLOBALS['TL_LANG']['tl_nc_notification']['editheader'][0] = 'Edit notification';
$GLOBALS['TL_LANG']['tl_nc_notification']['editheader'][1] = 'Edit notification ID %s.';
$GLOBALS['TL_LANG']['tl_nc_notification']['copy'][0] = 'Copy notification';
$GLOBALS['TL_LANG']['tl_nc_notification']['copy'][1] = 'Copy notification ID %s.';
$GLOBALS['TL_LANG']['tl_nc_notification']['delete'][0] = 'Delete notification';
$GLOBALS['TL_LANG']['tl_nc_notification']['delete'][1] = 'Delete notification ID %s.';
$GLOBALS['TL_LANG']['tl_nc_notification']['show'][0] = 'Notification details';
$GLOBALS['TL_LANG']['tl_nc_notification']['show'][1] = 'Show details for notification ID %s.';
$GLOBALS['TL_LANG']['tl_nc_notification']['title_legend'] = 'Title & type';
$GLOBALS['TL_LANG']['tl_nc_notification']['config_legend'] = 'Configuration';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['contao'] = 'Contao';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['core_form'][0] = 'Form submission';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['core_form'][1] = 'This notification type can be sent when the form is submitted.';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['member_activation'][0] = 'Member activation';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['member_registration'][0] = 'Member registration';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['member_personaldata'][0] = 'Member personal data';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['member_password'][0] = 'Member lost password';
$GLOBALS['TL_LANG']['tl_nc_notification']['templates'][0] = 'Token Templates';
$GLOBALS['TL_LANG']['tl_nc_notification']['templates'][1] = 'Choose templates to generate tokens from their output. Each template name must start with notification_xxx and its token will be converted to a ##template_xxx## token.';
$GLOBALS['TL_LANG']['tl_nc_notification']['templates_legend'] = 'Templates';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['newsletter_subscribe'][0] = 'Newsletter subscribed';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['newsletter_activate'][0] = 'Newsletter activation';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['newsletter_unsubscribe'][0] = 'Newsletter unsubscribed';

/**
 * notification_center extension for Contao Open Source CMS
 *
 * @copyright  Copyright (c) 2008-2015, terminal42
 * @author     terminal42 gmbh <info@terminal42.ch>
 * @license    LGPL
 */

$GLOBALS['TL_LANG']['tl_nc_notification']['type']['event_registration']         = 'Contao';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['registration_status']['0']   = 'Confirmation event register/unregister';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['registration_status']['1']   = 'This notification type will be sent after the confirmation event register/unregister.';

/**
 * news_newsletter extension for Contao Open Source CMS
 *
 * @copyright  Copyright (c) 2008-2014, terminal42 gmbh
 * @author     terminal42 gmbh <info@terminal42.ch>
 * @license    http://opensource.org/licenses/lgpl-3.0.html LGPL
 * @link       http://github.com/terminal42/contao-news_newsletter
 */

/**
 * Notification types
 */
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['news_newsletter']         = 'News newsletter';
$GLOBALS['TL_LANG']['tl_nc_notification']['type']['news_newsletter_default'] = array('Default', 'This notification type can be sent when the news article is published.');
